5 DIM L$(1:200),N1$(1:25),F$(1:17),M$(12:3)
6 DIM B$(1:64),D$(1:64),X$(1:64),Z$(1:64),M9$(1:31),D1$(1:31)
7 DIM P(3,3)
9 S9=0\GOTO 100
REM    Function to
10 DEF FNC(X,L1,L2)
11 IF X<L1 THEN RETURN 0
12 IF X>L2 THEN RETURN 0
13 RETURN 1
19 FNEND
REM   Input function
30 DEF FNI(X$,L1,L2)
31 PRINT X$," : ",\ INPUT1 "",Z$\ Z=FNV(Z$)
32 IF Z=>L1 AND Z<=L2 THEN PRINT\ RETURN Z
33 PRINT " INVALID! (",L1," to",L2,")"\ GOTO 31
39 FNEND
REM   Function to do binary search to find record address
REM   in the index
40 DEF FNL(P)
41 Z1=1\ Z2=I9
42 Z3=INT((Z1+Z2)/2)\ Z4=I(Z3)
43 IF P=Z4 THEN 46
44 IF P<Z4 THEN Z2=Z3-1 ELSE Z1=Z3+1
45 IF Z2<Z1 THEN RETURN 0 ELSE 42
46 Z=X(Z3)\ F5=INT(Z/10000)\ Z=Z-F5*10000
47 RETURN Z
49 FNEND
REM    Function to
50 DEF FNP$(X,N)
51 Z$=STR$(X,%#8I)\ X$=""
52 FOR I=1 TO 8\ Z1$=MID$(Z$,I,I)
53 IF Z1$=" " THEN X$=X$+"0" ELSE X$=X$+Z1$
54 NEXT
55 X$=RIGHT$(X$,N)\ RETURN X$
59 FNEND
REM    Function to get yes or no answer
60 DEF FNQ(Z$)
61 IF LEFT$(Z$,1)="Y" OR LEFT$(Z$,1)="y" THEN RETURN 1
62 RETURN0
69 FNEND
REM   Function to check validity of numeric data
70 DEF FNV(Z$)
71 Z2,Z5=0\ Z1=LEN(Z$)\ IF Z1=0 THEN RETURN -1
72 FOR Z3=1 TO Z1\ Z1$=MID$(Z$,Z3,Z3)\ Z4=ASC(Z1$)-48
73 IF Z4=-2 AND Z5=0 THEN Z5=10\ GOTO 76
74 IF Z4<0 OR Z4>9 THEN Z2=-1\ EXIT 77
75 IF Z5=0 THEN Z2=Z2*10+Z4 ELSE Z2=Z2+(Z4/Z5)\ Z5=Z5*10
76 NEXT
77 RETURN Z2
79 FNEND
REM   Initialize system & open files
100 FILE:2,LIST\ON ERROR GOTO 300
102 FILE:4,OPEN,"DAT",INPUT\INPUT:4,D
106 D1$=FND1$(D)\D=FND(D1$)\D$=FND$(D)
120 PRINT CHR$(12),TAB(17), "Inventory Control System"
121 PRINT TAB(29-(LEN(D$)/2)),D$\PRINT\ PRINT
138 PRINT "Make sure that the data disks are in the proper drives:"
140 PRINT\PRINT TAB(16),"DATA-2  goes in drive # 2"
141 PRINT\ PRINT TAB(16),"DATA-3  goes in drive # 3"
142 PRINT\INPUT "When you are ready, hit RETURN...",A$
143 REM
144 FILE:4,OPEN,"<?>Inventory-2",INOUT\INPUT:4,X9
145 FILE:4,CLOSE
146 IF X9>600 THEN I9=1200 ELSE I9=600
148 DIM I(I9),X(I9)
149 FILE:4,OPEN,"Index.DT",INPUT
150 PRINT
152 PRINT "Index file opened.  Reading index..."
154 MAT INPUT:4, I,X
156 PRINT "Done reading index table."\ FILE:4,CLOSE
158 FILE:4,OPEN,"<?>Inventory-2",INOUT
159 IF X9<601 THEN 162
160 FILE:5,OPEN,"<?>Inventory-3",INOUT
162 GOTO 800
REM    Can't open or read index file
170 PRINT CHR$(12)
172 PRINT TAB(24),"****************"\ PRINT
174 PRINT "I can't open data files. What do you want to do:"
176 PRINT\ PRINT "       1. Abort"
178 PRINT\ PRINT "       2. Create Index"
180 PRINT\ PRINT "       3. Try again"
181 PRINT\ PRINT "       4. Initialize Files"
182 PRINT\ N=FNI("Function",1,4)
184 ON N GOTO 186,188,120,190
186 Z=CALL(1027)
188 CHAIN "CREATE-INDEX"
190 CHAIN "FILECREATE"
REM   Error processing for file opening
300 IF LINE=149 THEN 170
310 IF LINE=144 THEN 170
320 IF LINE=160 THEN 170
390 PRINT ERR," in line ",LINE
395 RESET(ERR)
399 STOP
REM     Subroutine to write stock record
400 FILE:F5,POS,I1
410 WRITE:F5,N1,V1,U9,M,P1,P2,P3,
420 WRITE:F5,D1,D2,D3,Q1,Q2,Q3,D4,D5,
430 WRITE:F5,C,L,B,N1$
435 IF S9=1 THEN 449
440 FILE:F5,REW
449 RETURN
REM     Subroutine to read stock record
450 FILE:F5,POS,I1
452 READ:F5,N1,V1,U9,M,P1,P2,P3
454 READ:F5,D1,D2,D3,Q1,Q2,Q3,D4,D5
456 READ:F5,C,L,B,N1$
458 RETURN
REM  Screen Display routine
500 Z4$=""\ IF B<=M THEN Z4$=" ***"
502 IF (B+Q1+Q2+Q3)<=M THEN Z4$=" $$$"
504 PRINT FNP$(N1,6),": ",N1$,TAB(44),"Vendor:",V1\ PRINT
506 PRINT TAB(8),"PO #",TAB(28),"PO Date",TAB(47),"Quantity"
508 IF P1>0 THEN PRINT TAB(7),P1,TAB(28),FND$(D1),TAB(48),Q1,
510  PRINT
512 IF P2>0 THEN PRINT TAB(7),P2,TAB(28),FND$(D2),TAB(48),Q2,
514  PRINT
516 IF P3>0 THEN PRINT TAB(7),P3,TAB(28),FND$(D3),TAB(48),Q3,
518  PRINT
520 PRINT
522 PRINT "Balance On Hand: ",%6I,B,Z4$,
524  PRINT TAB(33),"Last Receipt: ",TAB(52),FND$(D4)
526 PRINT "Reorder Point:   ",%6I,M,
528  PRINT TAB(33),"Last Issue:   ",TAB(52),FND$(D5)
530 PRINT "On order:        ",%6I,Q1+Q2+Q3,
532  PRINT TAB(33),"Average Cost:    ",%$C12F2,C
534 PRINT "Issued to date:  ",%6I,U9,
536  PRINT TAB(33),"Inventory Value: ",%$C12F2,C*B
538 PRINT
549 RETURN
REM      Print a line of the transaction register
560 Z4$=" "
562 IF B<=M THEN Z4$="***"
564 IF (B+Q1+Q2+Q3)<=M THEN Z4$="$$$"
566 PRINT:2, FNP$(N1,6),TAB(8),N1$,TAB(34),T9$,TAB(43),
568 PRINT:2, %6I,Q9,TAB(56),%6I,B,TAB(64),Z4$
570 IF P1=0 THEN 584
572 PRINT:2,TAB(8),"PO #",P1," Date:",FND$(D1),TAB(56),%6I,Q1
574 IF P2=0 THEN 584
576 PRINT:2,TAB(8),"PO #",P2," Date:",FND$(D2),TAB(56),%6I,Q2
578 IF P3=0 THEN 584
580 PRINT:2,TAB(8),"PO #",P3," Date:",FND$(D3),TAB(56),%6I,Q3
582 IF T9=6 THEN 599
584 PRINT:2, " "
599 RETURN
REM     Head up the Transaction Register
600 IF J7=0 THEN PRINT:2, CHR$(12),
602 PRINT:2,TAB(15),"Prepared on ",D$
604 PRINT:2,CHR$(11)
605 PRINT:2,"Inventory Transaction Register",TAB(35),
606  PRINT:2, Z5$,TAB(49),"(Below Minimum =",TAB(64),"***)"
608 FOR Z4=1 TO 80\ PRINT:2,"_",\ NEXT\ PRINT:2," "
610 PRINT:2,"ITEM",TAB(8),"DESCRIPTION",TAB(34),"TRANS",
612  PRINT:2, TAB(43),"TRANSACTION",TAB(56),"NEW"
614 PRINT:2," #  ",TAB(34),"CODE",TAB(43),"QUANTITY",
616  PRINT:2, TAB(56),"BALANCE"
618 FOR Z4=1 TO 80\ PRINT:2,"_",\ NEXT\ PRINT:2," "
629 RETURN
REM      Subroutine-ask is data OK ?
630 T8$=" "\ INPUT "Is data OK? ",T8$
635 IF LEN(T8$)=0 THEN 630
639 RETURN
REM  Input a date and check for validity
640 D9$=" "\ INPUT1"",D9$
645 J9=FND(D9$)
646 IF J9=-1 THEN J9=D
647 PRINT " ",FND$(J9)
650 IF J9=0 OR J9>D THEN 660
655 RETURN
660 PRINT "Date INVALID. Re-enter (mm/dd/yy) : ",
665 GOTO 640
REM       A common get to the beginning
670 PRINT
672 GOTO 902
REM    Accept input of Stock number
674 N1=FNI("Stock number",1,999999)
676 I1=FNL(N1)\ IF I1>0 THEN PRINT CHR$(12),\ RETURN
678 PRINT "** No record of that Stock Number **"\ GOTO 674
REM   Post another part number or return to the menu
680 Z$=" "
681 INPUT"...type Y to continue, RETURN to return to posting menu : ",Z$
685 Q=FNQ(Z$)\ RETURN
700 DEFFND(M9$)
701 E=0 \ G=LEN(M9$) \ IF G=0 THEN RETURN -1 ELSE IF G<>8THEN RETURN 0
702 M8$=RIGHT$(M9$,2) \ G3=VAL(M8$) \ IF E=1 THEN RETURN 0
703 M8$=LEFT$(M9$,2)  \ G1=VAL(M8$) \ IF E=1 THEN RETURN 0
704 M8$=MID$(M9$,4,5) \ G2=VAL(M8$) \ IF E=1 THEN 706 ELSE GOSUB710
705 IF E=1 THEN RETURN 0 ELSE RETURN G3*10000+G1*100+G2
706 E=0 \ G2=G1 \ G1=LEN(M9$)-5 \ M8$=MID$(M9$,G1,G1+2)
707 RESTORE 713 \ FOR Y9=1 TO 12 \ READ X$\ IF X$=M8$ THEN G1=Y9
708 NEXT\IF G1=0 THEN RETURN 0 ELSE GOSUB 710\GOTO705
709 FNEND
710 IF G1<1 OR G1>12 THEN E=1 \ RETURN
711 RESTORE715\FORY9=1TOG1\READG4\NEXT\IFG2<1ORG2>G4THENE=1
712 RETURN
713 DATA "Jan","Feb","Mar","Apr","May","Jun"
714 DATA "Jul","Aug","Sep","Oct","Nov","Dec"
715 DATA 31,29,31,30,31,30,31,31,30,31,30,31
716DEFFND$(X)
719IFX=-1THENRETURN""
721G1=INT(MOD(X,10000)/100)\RESTORE713\FORY9=1TOG1\READX$\NEXT
724M9$=STR$(X)
726 RETURN X$+" "+RIGHT$(M9$,2)+","+LEFT$(M9$,3)
728FNEND
730 DEF FND1$(X)
731 M9$=STR$(X)
736 M9$=MID$(M9$,4,5)+"/"+MID$(M9$,6,7)+"/"+MID$(M9$,2,3)
738 RETURN M9$
740 FNEND
REM    Select processing and bring in appropriate routine
800 ON ESCAPE GOTO 800
801 PRINT CHR$(12),TAB(8),"PolyMorphic Systems Inventory Control"
802 PRINT\PRINTTAB(27-(LEN(D$)/2)),D$\PRINT
803 PRINT "Functions you can select:"
804 PRINT
806 PRINT "	1.  Post Inventory Transactions"
808 PRINT "	2.  Print the Stock Status Report"
810 PRINT "	3.  Enter new Part Numbers"
811 PRINT "	4.  Zero the Usage to Date"
812 PRINT
814 PRINT "	5.  End program"
816 PRINT
818 N=FNI("Function you want ",1,5)
820 ON N GOTO 822,824,826,830,850
822 CHAIN "POST"
824 CHAIN "STATUS"
826 CHAIN "ENTER"
830 INPUT "...is that what you REALLY want to do ? ",Z$
835 IF FNQ(Z$)<>1 THEN 800
840 CHAIN "ZERO"
850 Z=CALL(1027)\REM  This returns to Exec
