;	BASIC - direct command overlay
; Last Updated:
;	12/29/79	RTM	Disaster recovery, two user.
;	1/2/80		RTM	Faster gotos (clock date)
;	1/31/80		RTM	one/two user cleanups (date)
;	2/26/80		RTM	clock date for devlocks
;	3/25/80		RTM	Use root checksum
;	6/16/80		RTM	Make BASIC return to caller
;	7/16/80		RTM	Stack bugs!
;	2/3/81		DKM	Increase File Channels
;	2/3/81		DKM	Add LIST pause code
;	2/4/81		DKM	Add REN:x,N1,N2 with error
;				reporting of missing line
;				numbers
;	6/2/81		FEA	Added conditional assembly for
;				protected version.
;
; References for monitor & disk system

	REFS	SYSTEM

	REF	OVRLY
	REF	Err
	REF	Rtn
	REF	Fold
	REF	Ioret
	REF	WH1
	REF	WH0
	REF	KBUF
	REF	KBIP
	REF	MEMTOP
	REF	PVEC
	REF	Msg
	REF	SBRK
	REF	KBIG
	REF	USER
	REF	CMPTR

CR	EQU	0DH

; Stuff defined in the BASIC root

	REFS	Basic

	REF	ARG

	REF	BAERR
	REF	BARG
	REF	BEG
	REF	Bcheck
	REF	BfilOV
	REF	BOFA
	REF	BPRIM
	REF	BSERR
	REF	BUFA
	REF	BUFTP

	REF	CCLEAR
	REF	CCRLF
	REF	CFF
	REF	CFORM
	REF	CFRAC
	REF	CHOUT
	REF	CMND1
	REF	CNS
	REF	CRLF
	REF	CRUN
	REF	CSCR
	REF	CWAIT
	REF	CWIDTH

	REF	DCMP
	REF	DEL
	REF	DFC
	REF	DIRF
	REF	DLOAD
	REF	DSTOR
	REF	DSUB

	REF	EATL0
	REF	EATRP
	REF	ELSERW
	REF	EN
	REF	EOBUF
	REF	EOF
	REF	EOFA
	REF	EQUAL1
	REF	ERM1B
	REF	ERRHOLE
	REF	ERROR
	REF	ERRPT
	REF	EXITRW
	REF	EXP
	REF	EXPR2

	REF	FADD
	REF	FDIV
	REF	FINDLN
	REF	FLOAT
	REF	FMUL
	REF	FPBUF
	REF	FPBYT
	REF	FPNIB
	REF	FPNONE
	REF	FPONE
	REF	FPOUT
	REF	FPSINK
	REF	FPSIZ
	REF	FP655
	REF	FPRES
	REF	FPDIN
	REF	FSET
	REF	FSUB
	REF	FULLBASIC

	REF	GC
	REF	GCI
	REF	Glarg
	REF	GOSURW
	REF	GOTORW

	REF	HALF
	REF	Hmath

	REF	IBCNT
	REF	IBLN
	REF	IBP
	REF	IBUF
	REF	IBUF1
	REF	INSA
	REF	INTEGER
	REF	INTEGER0

	REF	LHLI
	REF	LNRW
	REF	LNUM
	REF	LOGe10
	REF	LOGe2

	REF	NAME
	REF	NFCHAN
	REF	NLN
	REF	NOSE

	REF	OBERR
	REF	OBP
	REF	OBUF
	REF	OFN
	REF	OLDTERM
	REF	ONCEB
	REF	OUN

	REF	PARSUM
	REF	PCHECK
	REF	PFIXE
	REF	PHEAD
	REF	PI
	REF	PIhalf
	REF	POPFP
	REF	PRNT
	REF	PRNTCR
	REF	PROTBASIC

	REF	RBUF
	REF	RESTRW
	REF	RINIT
	REF	RWT

	REF	SCANC
	REF	Scheck
	REF	SCOMA
	REF	Sflag
	REF	SOERR
	REF	SPTR
	REF	SNAME
	REF	SSTACK
	REF	STAA
	REF	STSEP

	REF	TAIL
	REF	TEMP1
	REF	TEMP2
	REF	THENRW
	REF	TSTKA
	REF	TXA

	REF	VAR
	REF	VCOPY

	REF	WALKFLG

	ORG	OVRLY
	IDNT	$,$
	DB	'Bdir'

;  This is the control section to select routines

ENTRY	XTHL
	PUSH	D
	MOV	L,A
	MVI	H,0
	DAD	H
	LXI	D,FUNCTIONLIST
	DAD	D
	MOV	E,M
	INX	H
	MOV	D,M
	XCHG
	POP	D
	XTHL
ret	EI
	RET

	IF	FULLBASIC
FUNCTIONLIST
	DW	CLIST		; 0
	DW	CREN		; 1
	DW	Cold		; 2
	DW	EP0		; 3
	DW	LineEditor	; 4
	DW	CDEL		; 5
	DW	HardMath	; 6
	DW	DIGITS		; 7
	ELSEIF	PROTBASIC
FUNCTIONLIST
	DW	ret		; 0
	DW	ret		; 1
	DW	Cold		; 2
	DW	EP0		; 3
	DW	ret		; 4
	DW	ret		; 5
	DW	HardMath	; 6
	DW	DIGITS		; 7
	ENDIF

; some MACRO fun...

db	MACRO
#L	DB	#A
	ENDM

Remember MACRO
#L	SHLD	Junk
	LHLD	OVRLY
	PUSH	H
	LHLD	OVRLY+2
	PUSH	H
	LXI	H,Rtn
	PUSH	H
	LHLD	Junk
	ENDM

Junk	DW	0	; temp holder!

	MACLIST	0

; we need to do this because these routines
; may call one of the other overlays

Pfixe	Remember
	JMP	PFIXE

Cclear	Remember
	JMP	CCLEAR

CMPDH	MOV	A,D
	CMP	H
	RNZ
	MOV	A,E
	CMP	L
	RET
	PAGE
; Start code for BASIC.  Function code in A:
;	2) Cold Start - checksum the resident
;	3) Warm Start

Cold	PUSH	PSW
	LXI	H,USER
	LXI	D,Bcheck+1
	MVI	C,0

Cold1	MOV	A,C
	ADD	M
	MOV	C,A
	INX	H
	MOV	A,E
	CMP	L
	JNZ	Cold1
	MOV	A,D
	CMP	H
	JNZ	Cold1
	INR	C		; increment checksum
	JZ	EPP0		; jmp/it's ok.

; Resident checksum STINKS. Die.

	LXI	D,0DEADH
	JMP	Err

; Normal startup code.
EPP0	POP	PSW
EP0	PUSH	PSW		; save function code.
	LXI	H,2		; initial stack pointer
	DAD	SP		; 2 offset for overlays!
	SHLD	SSTACK
	POP	PSW
	LXI	H,CMND1		; return to command loop
	PUSH	H
	LXI	H,Ioret		; BASIC panic vector.
	SHLD	PVEC
	CPI	2
	JZ	START		; no carry entry

WARM	STC			; set same for this path.

; The first thing to do is assign space to variable
; length holes for numbers in BASIC.  This was added
; to allow user defined precision.  We will fall thru
; the warm start code when precision is redefined.
; The order in which these spaces are assigned should not
; be changed without carefully noting the requirements
; of the routines that establish the values of constants.

;	Note: If we enter with CARRY SET, it's a Warm start.

START	PUSH	PSW		; preserve carry bit..
	MVI	A,1		; put us in direct mode
	STA	DIRF		; in case of errors
	CALL	VarPrec		; setup var prec "holes"
	LHLD	SSTACK
	SHLD	SPTR		; start point for BASIC stack
	CALL	FSET		; file initialization
	POP	PSW
	JNC	ST1		; cold start

; Warm start.

	MVI	A,80H		; says no funnies
	STA	ONCEB
	LHLD	BOFA
ST2	MOV	A,M		; find program end
	CPI	EOF
	JZ	ST3
	CALL	SUBA		; "add" line length
	JMP	ST2

ST3	SHLD	EOFA		; program end marker
	CALL	CCLEAR		; clear variables
	JMP	ST4		; ignore cold start stuff

; Cold start.

ST1	CALL	CSCR		; SCRATCH program and variables
	XRA	A
	STA	ONCEB		; so we will print init message

; now come some funnies...

	LHLD	CMPTR		; Exec command ptr
	MOV	A,M
	CPI	CR		; see if something to do
	JNZ	NamBS		; jmp/ yup, file on command line
; Stuff the initial text into the buffer.

	LXI	D,INtxt		; addr of init text
	LXI	H,IBUF1		; our buffer
ITcpy	LDAX	D
	MOV	M,A
	INX	D
	INX	H
	CPI	CR
	JNZ	ITcpy		; simple.
	JMP	ST4		; finish initialization

; We were entered by the Exec when somebody invoked a
; file with the extension .BS- Let's set up to load same.

NamBS	PUSH	H		; save ptr to file name
	LXI	D,LDtxt		; 'LOAD,'
	LXI	H,IBUF1		; put here
LDcpy	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	CPI	','
	JNZ	LDcpy		; copy 'LOAD,' into buf.

	MVI	A,7FH		; special setting
	STA	ONCEB		; to force us to run!
	POP	D		; get CMPTR back
FNcpy	LDAX	D
	MOV	M,A
	INX	D
	INX	H
	CPI	CR
	JNZ	FNcpy		; loop putting in text.

; now resume rest of init process

ST4	CALL	CFF
	CALL	DFC		; set output format to default
	CALL	RINIT		; initialize RND seed
	RET
	PAGE
; Variable precision package
;	implemented by Thomas A. Crispin
;		(yecch.... RTM)

VarPrec	LXI	H,TAIL+3	; "end" of BASIC's guts
	SHLD	BUFTP		; "top" of FP buffer
	DCX	H
	LDA	FPNIB
	CALL	ADR
	SHLD	FPBUF		; FP buffer
	LDA	FPBYT
	ADI	3
	CALL	ADR
	SHLD	BPRIM		; B' buffer for FP ops
	LDA	FPBYT
	CALL	ADR
	SHLD	RBUF		; buffer for division
	CALL	ADRFP
	SHLD	ERRHOLE		; hole for the ERR code
	CALL	ADRFP
	SHLD	BARG
	CALL	ADRFP
	SHLD	FPSINK		; general purpose FP buffer
	CALL	ADRFP
	SHLD	TEMP1		; buffer intrinsic functions
	CALL	ADRFP
	SHLD	TEMP2		; likewise..
	CALL	ADRFP
	INX	H
	INX	H
	INX	H
	INX	H
	SHLD	EOBUF
	CALL	ADRFP
	SHLD	EN		; power series term
	CALL	ADRFP
	SHLD	OLDTERM		; power series term
	CALL	ADRFP
	SHLD	PARSUM		; power series term
	CALL	ADRFP
	SHLD	HALF		; constant 1/2
	CALL	ADRFP
	SHLD	ARG		; power series term
	CALL	ADRFP
	SHLD	LOGe10		; constant ln(10)
	CALL	ADRFP
	SHLD	LOGe2		; constant ln(2)
	CALL	ADRFP
	SHLD	FP655		; constant 65536
	CALL	ADRFP
	SHLD	PI		; constant PI = 3.14..
	CALL	ADRFP
	SHLD	PIhalf		; constant PI/2
	CALL	ADRFP
	SHLD	FPONE		; constant 1
	PUSH	H
	CALL	EQUAL1		; (initialize FPONE)
	POP	H
	CALL	ADRFP
	SHLD	FPNONE		; constant -1
	CALL	NEGONE		; (initializa FPNONE)
	SHLD	NOSE		; END OF BASIC ROOT
	XCHG
	LHLD	MEMTOP
	DCX	H
	SHLD	BOFA		; program can start here..
	XCHG
	CALL	CMPDH
	LXI	D,206H		; not nuff memory
	JC	Err		; jmp/ report error

; Set up the constant 1/2.

	LHLD	HALF
	MVI	M,40H
	LDA	FPBYT
half	DCX	H
	MVI	M,0
	DCR	A
	JNZ	half
	MVI	M,50H

; Set up constant ln(10)

	LHLD	LOGe10
	MVI	M,41H
	LHLD	ARG		;previous hole
	LXI	D,loge10
	CALL	SETCON

; Set up constant ln(2)

	LHLD	LOGe2
	MVI	M,40H
	LHLD	LOGe10		;previous hole
	LXI	D,loge2
	CALL	SETCON

; Set up constant 65536

	LHLD	LOGe2		;previous hole
	INX	H
	MVI	M,65H
	INX	H
	MVI	M,53H
	INX	H
	MVI	M,60H
	LHLD	FP655
	MVI	M,45H

; Set up constant PI

	LHLD	PI
	MVI	M,41H
	LHLD	FP655		;previous hole
	LXI	D,pi
	CALL	SETCON

; Set up constant PI/2

	LHLD	PIhalf
	MVI	M,41H
	LHLD	PI		;previous hole
	LXI	D,pihalf
	CALL	SETCON
	RET

;	Utilities used in above code.

;  Set a floating constant to the required accuracy.
;  HL points at exponent of PREVIOUS constant.
;  DE points to the data table at Bdir's end.

SETCON	INX	H
	LDA	FPBYT
	MOV	B,A
SETCON1
	LDAX	D
	MOV	M,A
	INX	H
	INX	D
	DCR	B
	JNZ	SETCON1
	RET

; Set variable pointed to by HL to -1.

NEGONE	PUSH	H
	CALL	EQUAL1
	POP	H
	MVI	M,0C1H
	RET
	PAGE
; Hardware Math Interface
;	BASIC has detected a North Star Hardware FP board.
;
;	We come here on the first RUN with precision <=14.
;	And on subsequent RUNs if the precision has been
;	changed and DIGITS says it is within the FPB range.
;
;	We simply(!!) over-write the software FP math with
;	the appropriate hardware math code. (blah... RTM)

HardMath
	DI			; Don't disturb this guy!!
	LDA	FPNIB
	STA	Hmath
	PUSH	PSW		; Save this..
	RLC
	RLC
	RLC
	RLC
	STA	FPNIB		; 'cause we need FPNIB * 16
	LXI	D,FMUL+5	; "FPB" code goes here

; Hardware FP math - ADDITION.

	LXI	H,FADD
	MVI	B,1
	CALL	FPBset

; Hardware FP math - SUBTRACTION.

	LXI	H,FSUB
	MVI	B,2
	CALL	FPBset

; Hardware FP math - MULTIPLICATION.

	LXI	H,FMUL
	MVI	B,3
	CALL	FPBset

; Hardware FP math - DIVISION.

	LXI	H,FDIV
	MVI	B,4
	CALL	FPBset

; Now we set up the "FPB" code.  If you want to know how
; and why it works, see NORTH STAR's manual for it's board.
;
	XCHG			; address of "FPB" into HL
	MVI	M,21H		; LXI	H,
	INX	H
	LXI	D,OBUF+10		; buffer address
	CALL	DSTOR
	MVI	M,0F3H		; DI
	INX	H
	MVI	M,77H		; MOV	M,A
	INX	H
	MVI	M,0C5H		; PUSH	B
	INX	H
	MVI	M,3AH		; LDA
	INX	H
	LXI	D,FPRES		; FP board restart address
	CALL	DSTOR
	MVI	M,7EH		; MOV	A,M
	INX	H
	CALL	FPB1st		; code to get RH argument
	CALL	FPB2nd		; code to get LH argument
	MVI	M,0C1H		; POP	B
	INX	H
	MVI	M,21H		; LXI	H
	INX	H
	LXI	D,FPDIN		; FP board status port
	CALL	DSTOR
;	MVI	M,0FBH		; EI
;	INX	H
	PUSH	H			; save address for a jump
	MVI	M,7EH		; MOV	A,M
	INX	H
	MVI	M,0B7H		; ORA	A
	INX	H
	MVI	M,0F2H		; JP
	INX	H
	POP	D			; get that jump address!
	CALL	DSTOR
;	MVI	M,0F3H		; DI
;	INX	H
	MVI	M,0E6H		; ANI
	INX	H
	MVI	M,12Q		; 12Q
	INX	H
	CALL	FPB3rd		; code to get result from board
	MVI	M,0FBH		; EI
	INX	H
	MVI	M,0C8H		; RZ
	INX	H
	MVI	M,0EH		; MVI	C
	INX	H
	MVI	M,23		; 23 (overflow error)
	INX	H
	MVI	M,0C3H		; JMP
	INX	H
	LXI	D,ERROR		; Error handler
	CALL	DSTOR
	POP	PSW
	STA	FPNIB		; recover FPNIB
	EI
	RET

; Initialization code for FP operations.

FPBset	MVI	M,3EH		; MVI	A,
	INX	H
	LDA	FPNIB		; FPNIB * 16 + op flag in B
	ADD	B
	MOV	M,A
	INX	H
	MVI	M,0C3H		; JMP
	INX	H
	CALL	DSTOR		; DE has address of "FPB"
	RET

; Establish the code that passes RH Arg to FP board.
; Note that it varies with the BASIC precision.

FPB1st	LDA	FPSIZ
FPB1	MVI	M,1AH		; LDAX	D
	INX	H
	DCR	A
	RZ
	MVI	M,1BH		; DCX	D
	INX	H
	JMP	FPB1

; Establish the code that passes LH Arg to FP board.
; It also varies with the BASIC precision.

FPB2nd	LDA	FPSIZ
FPB2	MVI	M,0AH		; LDAX	B
	INX	H
	DCR	A
	RZ
	MVI	M,0BH		; DCX	B
	INX	H
	JMP	FPB2

; Establish the code that gets the result from FP board.
; It, too, varies with the BASIC precision.

FPB3rd	LDA	FPSIZ
FPB3	MVI	M,7EH		; MOV	A,M
	INX	H
	MVI	M,02H		; STAX B
	INX	H
	DCR	A
	RZ
	MVI	M,0BH		; DCX	B
	INX	H
	JMP	FPB3
	PAGE
	IF	FULLBASIC
; UN-PRE-PROCESSOR
;
;	It takes a program line (address in HL) and
;	translates it into text at the buffer (address
;	in DE).  Remember that the program is in memory
;	BACKWARDS - and that we also write the text into
;	the buffer BACKWARDS.
;	The address of the source CR is returned in HL.

UPPL	DCX	H		; skip count byte
	DCX	H
	PUSH	H		; source TXA
	CALL	LHLI		; get line number
	CALL	CNS		; convert to decimal
UPP	POP	H		; bypass the line number
UPP0	DCX	H
	MOV	A,M		; next source character
	CPI	LNRW		; check for coded line number
	JZ	UPP5
	ORA	A
	JM	UPP1		; it's a token or reserved word
	STAX	D		; copy  verbatim into buffer
	CPI	CR		; we are done if it's a CR
	RZ
	DCX	D
	JMP	UPP0		; go do some more

; Token - reserved word translation code.

UPP1	PUSH	H		; save source pointer
	LXI	H,RWT		; base of reserved word table
UPP2	CMP	M		; compare RW with table
	INX	H
	JNZ	UPP2		; loop until we find a match

; We have a match.  Now we copy the text of the RW from
; the RWT into the buffer.  When we get an ASCII character
; => 200Q, we are finished copying.

UPP3	MOV	A,M
	ORA	A
	JM	UPP4		; done - this is a RW token
	STAX	D
	DCX	D
	INX	H
	JMP	UPP3

UPP4	POP	H		; recover source pointer
	JMP	UPP0		; do more

; Coded line number translation.

UPP5	DCX	H		; skip LNRW
	DCX	H
	PUSH	H
	CALL	LHLI		; get hex line number
	CALL	CNS		; send to buffer as decimal
	JMP	UPP		; go do more
	PAGE
; DEL command.		format : DEL N1,N2
;
;	Delete lines N1 thru N2, inclusive, of the BASIC
;	program in memory.  If N2 is not specified, then
;	delete ONLY line N1.

CDEL	CALL	Scheck		; but NOT for protected files
	LXI	H,Ioret		; panic vector reset
	SHLD	PVEC
	LXI	H,1
	SHLD	OUN		; establish video as out port
	CALL	GLARG		; get address of N1
	PUSH	H		; and save it
	DCX	H		; point at line #
	DCX	H
	CALL	LHLI		; get line # into HL
	JNZ	DEL1		; not exact match
	INX	H		; add 1
DEL1	PUSH	H
	CALL	SCOMA		; eat possible comma
	JNZ	DEL2		; jump if NO N2
	CALL	GC		; get past blanks
	CALL	INTEGER0
	JC	BAERR		; jmp/ not an integer
	INX	H		; need N2 + 1
	XTHL			; swap it for N1
DEL2	POP	H
	SHLD	OBUF		; save as finish indicator
	CALL	GCR		; must end with CR
	POP	H		; address of line N1
	XRA	A
	STA	SBRK

; Since we are deleting lines, the address of N1 will always
; be the address of a line we delete.  Should we get to the
; end of the BASIC program (we sense an EOF), we better stop.

DEL3	MOV	A,M
	CPI	EOF
	RZ

;With program backwards in memory, we do this funny style.
;Will upset your digestion if inspected closely.

	PUSH	H		; save N1 address
	DCX	H
	DCX	H
	CALL	LHLI		; get "line #" into HL
	SHLD	IBLN		; save it here for editor
	XCHG			; put into DE
	LXI	H,OBUF		; compare with finish #
	CALL	DCMP
	POP	H		; recover N1 address
	RNC			; NC means SPLIT - WE ARE DONE
	PUSH	H		; save N1 address again

; Set things up for the editor to delete the line.

	MVI	A,4
	STA	IBCNT		; line length = 4 means delete
	CALL	LineEditor
	CALL	PCHECK		; look for a control Y
	POP	H		; recover "N1" address
	JMP	DEL3		; loop
	PAGE
	ENDIF
; DIGITS command.		format : DIGITS N
;
;	Specify BASIC's precision.
;	The current limits are 6 to 26 for software
;	and 6 to 14 for hardware floating point.

DIGITS	CALL	Pfixe		; get precision
	MOV	A,E
	CPI	6		; 6 is the lower limit!
	MVI	C,32H
	JC	ERROR
	CPI	27		; and 26 is the upper limit!
	MVI	C,33H
	JNC	ERROR
	CPI	15		; > 14 digits?
	JC	DIGIT1		; jmp/ nope
	LDA	Hmath
	ORA	A		; hardware board envoked?
	MOV	A,E
	JZ	DIGIT1		; jmp/ nope
	MVI	C,30H		; Too many digits for hardware
	JMP	ERROR		; scream

DIGIT1	ANI	0FEH
	STA	FPNIB
	MOV	B,A
	RRC
	STA	FPBYT
	INR	A
	STA	FPSIZ
	LDA	Hmath		; hardware math?
	ORA	A
	JZ	DIGIT2
	CMP	B		; precision change?
	CNZ	HardMath
DIGIT2	CALL	VarPrec		; set the "holes"
	CALL	Cclear		; then CLEAR out variables
	RET
	PAGE
	IF	FULLBASIC
; LIST command.		format : LIST:N,N1,N2
;
;	List the BASIC program lines N1 thru N2 (inclusive)
;	to the device N.
;	List the entire program if N1 and N2 are not given.
;	If only N1 is given, list the entire program
;	STARTING with line N1.

CLIST	CALL	Scheck		; don't list protected files
	LXI	H,Ioret		; panic vector
	SHLD	PVEC
	LXI	H,1
	SHLD	OUN		; set output port to video
	CALL	GETOUN		; unless otherwise specified
	CNC	SCOMA		; eat the comma
	LHLD	EOFA		; end of program
	SHLD	N2		; is default for N2

	CALL	GLARG		; get first argument
	SHLD	N1		; save as N1
	JNC	List3		; jmp/ list entire program
	JZ	List1
	INX	H			; adjust if not perfect match
List1	PUSH	H
	CALL	SCOMA		; eat possible comma
	POP	H
	JNZ	List2		; jmp/ list N1 only

	CALL	GLARG		; get address of second arg
	JNC	List3		; jmp/ not there use default
	JZ	List2
	INX	H			; adjust if not perfect match
List2	SHLD	N2		; save our finish indicator
	CALL	GCR		; must end with CR

; The listing loop.

List3	LHLD	N1		; current line
	MOV	A,M
	CPI	EOF
	RZ			; no more program to list!
	XCHG
	LHLD	N2		; compare the finish address
	CALL	CMPDH		; with where we are now
	XCHG
	RC			; ret/ all done
	LXI	D,IBUF
	CALL	UPPL		; turn it into text
	DCX	H		; now we point at the next line
	SHLD	N1
	LXI	H,IBUF
	LXI	D,-1
	CALL	PRNTCR		; print the line
	CALL	PCHECK		; check for control Y
	CALL	CRLF
	PUSH	H		;Code added to cause LIST to
	PUSH	D		;  pause when key pressed
	LHLD	KBIG		;Check key get pointer
	XCHG
	LHLD	KBIP		; against put pointer
	CALL	CMPDH
	JZ	List4		;equal=>no key pressed
	CALL	WH0		;get character out of buffer
	CALL	WH0		;wait for next character
List4	POP	D		;restore regs
	POP	H
	JMP	List3		; loop

; Get line no argument for LIST & DEL commands.

GLARG	CALL	GC		; peek at next char
	CPI	CR
	JZ	GLA2		; jmp/ no argument given
	CALL	Glarg
	STC			; set carry
	RET

GLA2	LHLD	BOFA		; use start of program
	ORA	A		; clear carry
	RET

; line number argument variables

N1	EQU	OBUF		; starting address
N2	EQU	OBUF+2		; ending
	PAGE
; REN command.		format : REN:x,N1,N2
;
;	Renmumber the BASIC program starting at line
;	N1 with an increment of N2.  The default values
;	of both N1 and N2 are 10.

CREN	CALL	Scheck		; no REN for protected files
	LXI	H,Ioret		; reset panic vector
	SHLD	PVEC
	CALL	GETOUN		; get output channel number
	CNC	SCOMA		; eat comma, if there
	MVI	A,'I'		;set output format to 8I
	STA	CFORM
	MVI	A,8
	STA	CWIDTH
	LXI	H,10		; set default for..
	SHLD	BEG		; starting line #
	SHLD	DEL		; line # increment
	CALL	GC
	CALL	INTEGER0	; get N1
	JC	CREN1		; wasn't there - do whole thing
	SHLD	BEG		; save N1 as starting #
	CALL	SCOMA
	JNZ	CREN1		; no N2
	CALL	GC
	CALL	INTEGER0	; get N2
	JC	BAERR		; too big!
	MOV	A,H
	ORA	L
	JZ	OBERR		; can't use incrment of 0
	SHLD	DEL		; save N2 as increment
CREN1	CALL	GCR		; better end with CR

; We check to see that we won't create an overflow by
; our renumbering.

	LXI	D,0FFFFH
	CALL	FINDLN
	XRA	A			; clear the idiot flag
	STA	RenFlg

; Pass 1.  Adjust line # in GOTO, GOSUB, EXIT, etc.

	LHLD	BOFA		; start at beginning
R0	MOV	A,M
	CPI	EOF
	JZ	R5		; go do pass 2
	DCX	H		; count byte
	MOV	D,M		; get line number high byte
	DCX	H		; skip line # and count byte
	MOV	E,M		; get line number low byte
	XCHG
	SHLD	CurLine		; save line number
	XCHG
	DCX	H
	SHLD	TXA
R1	CALL	GCI
	CPI	CR
	JZ	R0		; end of line
	CALL	LNUM		; get a line number
	JC	R1		; wasn't there

; We come here with:
; line # in DE	 --  pointer to next char in HL and TXA

	XCHG			; FINDLN wants # in DE
	PUSH	D
	CALL	FINDLN		; find the line
	POP	D
	JC	R7		; couldn't
	JNZ	R7		; couldn't

; FINDLN does a lot of work.  In finding the line, it
; counts the number of lines it has scanned first and
; adjusts a counter to indicate what the new line #
; will be for that line.  Saves this in NLN.

	LHLD	NLN		; this has the new number
	XCHG
	LHLD	TXA		; where we put it (almost)
	INX	H
	INX	H
	MOV	M,D		; put in the new number
	DCX	H
	MOV	M,E
	DCX	H
	JMP	R1		; and loop

; Pass 2.  Change the program line numbers.

R5	LHLD	DEL		; line # increment
	MOV	B,H		; into BC
	MOV	C,L
	LHLD	BEG		; starting # to change
	XCHG			; into DE
	LHLD	BOFA		; beginning of program
R6	MOV	A,M		; count byte
	CPI	EOF		; loop 'till program end
	JZ	R8		; jmp/ exit
	PUSH	H		; current line
	DCX	H		; skip count byte
	MOV	M,D		; put in new line number
	DCX	H
	MOV	M,E
	POP	H		; current line
	CALL	SUBA		; A still has count
	XCHG			; next line to DE
	DAD	B		; old number + increment
	XCHG			; new number in DE ; line in HL
	JMP	R6		; loop
;
R7	PUSH	D		;save regs
	PUSH	H
	PUSH	B
	PUSH	PSW
	XCHG			;save bad line number
	SHLD	BadLine
	LHLD	CurLine		;get current line number again
	XCHG
	CALL	FINDLN		;get new line number for it
	LDA	RenFlg		;get renumber flag
	ORA	A		;is it zero
	CZ	RenHdr		;yes, let's give em the header
	MVI	A,0FFH		; set the flag to tell
	STA	RenFlg		; R8 there's an error
	CALL	RenDisp		;give the line numbers
	POP	PSW
	POP	B
	POP	H		;restore regs
	POP	D
	JMP	R1
;
R8	CALL	CFF		;reset to default format
	LDA	RenFlg		; well how does it look
	ORA	A
	RNZ			; ret/ looking bad...
	LXI	H,RenOk		;point to Ok message
	JMP	Msg		;return through message service
;
RenFlg	DS	1		; tells of any stray line refs
CurLine	DS	2		;current line number
BadLine	DS	2		;line number couldn't find
RenLnCt	DS	1		;screen line counter
RenOk	db	'  Renumbered Ok!',CR,0
RenMsg	db	9,'Renumbering Error:',CR
RenMsg1	db	'Old Line	New Line    Missing Line',CR
;
RenHdr	CALL	CCRLF		;do initial Cr Lf if necessary
	LXI	H,RenMsg	;point to message
	LXI	D,1		;index +1
	CALL	PRNTCR		;print it
	CALL	CRLF		;do Cr Lf
	LXI	H,RenMsg1	;point to next message line
	CALL	PRNTCR		;print it
	CALL	CRLF		;do another Cr Lf
	MVI	A,2		;initialize line counter
	STA	RenLnCt
	RET			;leave
;
RenDisp	LDA	OUN		;check output channel
	DCR	A		;is it one
	CZ	RenPause	;yes, show dot & wait
	LHLD	CurLine		;get current line number
	CALL	RenFlt		;convert it & print it
	CALL	RenSp		;print TAB
	LHLD	NLN		;get new line number
	CALL	RenFlt		;convert & print it
	CALL	RenSp		;print TAB
	LHLD	BadLine		;get bad line number
	CALL	RenFlt		;convert & print it
	CALL	CRLF
	LDA	RenLnCt		;bump line counter
	INR	A
	STA	RenLnCt
	RET
;
RenPause
	LDA	RenLnCt		;get line count
	CPI	15		;is it 15 yet
	RC			;no leave
	MVI	A,'.'		;display dot
	CALL	WH1
	CALL	WH0		;wait for keyboard char
	MVI	A,7FH		;delete it
	CALL	WH1
	JMP	RenHdr		;go do header
;
RenFlt	CALL	FLOAT		;push as F.P. onto stack
	CALL	POPFP		;get it back
	LHLD	TSTKA
	CALL	FPOUT		;convert into buffer
	LXI	D,1		;index +
	CALL	PRNT		;print it
	RET
;
RenSp	MVI	A,9		;print TAB once
	CALL	CHOUT
	RET
;
	PAGE
; The LINE EDITOR
;
;	BASIC has been given a program line to edit.
;	The following possibilities exist :
;	  It is a line to be deleted.
;	  It is a brand new line.
;	  It is a modification of an existing line.
;
;	The line itself will be in IBUF, the line length
;	will be in IBCNT ( where a 4 indicates delete ),
;	and the line number will be in IBLN.
;
;	NOTE : because the line is "BACKWARDS" in memory, some
;	of the processing may appear baroque

LineEditor
	LXI	H,IBLN		; get line # into DE
	CALL	LHLI
	XCHG
	LHLD	BOFA		; beginning of program

; Find whether is insertion, replacement or appended line.
; We search thru the program, looking for the least line #
; => the new line.

LIN0	MOV	A,M
	CPI	EOF
	JZ	APP		; append case.
	DCX	H
	DCX	H
	CALL	DCMP
	INX	H
	INX	H
	MVI	C,2
	JZ	INSR		; replacement case.
	MVI	C,1
	JC	INSR		; insertion case.
	MOV	A,M
	CALL	SUBA
	JMP	LIN0		; check the next line

; Append a line to the program.

APP	LDA	IBCNT
	CPI	4
	RZ			; don't append a null line
	CALL	FULL		; make sure we have room
	LHLD	EOFA
	CALL	IMOV		; stick line on end
	MVI	M,EOF
	SHLD	EOFA		; mark new end of file
	RET

; Insertion/replacement.

INSR	MOV	B,M		; count byte
	SHLD	INSA		; line address
	LDA	IBCNT		; new line length
	DCR	C
	JZ	LT		; an insertion
	SUI	4
	JZ	LT1		; new line length = 4 : delete
	ADI	4		; restore length
LT1	SUB	B		; compare with old line
	JZ	LIN1		; line lengths identical
	JC	GT		; replacement line is shorter

; Either :
;  The replacement line is longer than the original line.
; or
;  We are inserting a new line in the middle of program.

LT	MOV	B,A			; length difference
	LDA	IBCNT
LT2	CPI	4			; entry from append
	RZ			; don't insert a null line
	MOV	A,B
	CALL	FULL		; check for enough room
	LHLD	INSA
	CALL	NMOV		; get counter for block move
	LHLD	EOFA
	XCHG
	SHLD	EOFA		; mark new end of file
	INX	B
	CALL	LMOV		; shift block over
	JMP	LIN1		; go insert new line

; The replacement line is shorter than the original line.

GT	CMA
	INR	A
	CALL	SUBA
	CALL	NMOV		; get block move pointers
	XCHG
	LHLD	INSA
	CALL	RMOV		; shift the block
	MVI	M,EOF
	SHLD	EOFA		; reset end-of-file

; Insert the new line.  When we get here, the
; rest of the program has been shifted to make room.

LIN1	LHLD	INSA		; line insertion address
	LDA	IBCNT
	CPI	4
	RZ			; don't insert null line!

; Actual insertion code.

IMOV	LXI	D,IBCNT		; first (count) byte of line
	LDAX	D
	MOV	C,A			; # of bytes in C
	MVI	B,0

; Block move starting with high memory byte.
; Source address in DE, destination address in HL.
; The number of bytes to move is in BC.

RMOV1	LDAX	D
	MOV	M,A
	DCX	H
	DCX	D
	DCX	B
RMOV	MOV	A,B
	ORA	C
	JNZ	RMOV1
	RET

; Block move starting with low memory byte.
; Source address in DE, destination address in HL.
; The number of bytes to move is in BC.

LMOV1	LDAX	D
	MOV	M,A
	INX	D
	INX	H
	DCX	B
LMOV	MOV	A,B
	ORA	C
	JNZ	LMOV1
	RET

; Compute how many bytes to move.
; We return (HL) - (EOFA)  [remember program is BACKWARDS]
; in BC.  Z set indicates a zero count.

NMOV	PUSH	D
	PUSH	H
	XCHG
	LHLD	EOFA
	XCHG
	CALL	DSUB
	MOV	B,H
	MOV	C,L
	POP	H
	POP	D
	RET

; Routine to determine if enough free space exists for
; the new line.  The new EOFA is returned in DE.
; We do NOT have enough space if the program will
; encroach on the variable space.

FULL	LHLD	EOFA
	CALL	SUBA
	XCHG
	LXI	H,STAA
	CALL	DCMP
	JC	SOERR
	RET
	ENDIF
	PAGE
; Utility routines used by Bdir and data tables.

ADRFP	LDA	FPSIZ		; add FPSIZ to HL
ADR	ADD	L		; add A to HL
	MOV	L,A
	RNC
	INR	H
	RET

SUBA	DCR	A		; subtract A from HL
	SUB	L
	CMA
	MOV	L,A
	RC
	DCR	H
	RET

dcmp	DCX	H		; "backwards" compare DE to MEM
	MOV	A,D
	CMP	M
	INX	H
	RNZ
	MOV	A,E
	CMP	M
	RET

GETOUN	LXI	H,1
	SHLD	OUN
	MVI	A,':'
	CALL	SCANC
	RC
	CALL	Pfixe
	MOV	A,D
	ORA	A
	JNZ	OBERR
	MOV	A,E
	ORA	A
	JM	OBERR
	CPI	NFCHAN
	JNC	OBERR
	STA	OUN
	XRA	A		;clear that carry bit!
	RET

GCR	CALL	GC
	CPI	CR
	RZ
	JMP	BSERR

lhli	PUSH	PSW
	MOV	A,M
	DCX	H
	MOV	H,M
	MOV	L,A
	POP	PSW
	RET

loge10	db 23H,02H,58H,50H,92H,99H,40H,45H,68H,40H,17H,99H,15H

loge2	db 69H,31H,47H,18H,05H,59H,94H,53H,09H,41H,72H,32H,10H

pi	db 31H,41H,59H,26H,53H,58H,97H,93H,23H,84H,62H,64H,34H

pihalf	db 15H,70H,79H,63H,26H,79H,48H,96H,61H,92H,31H,32H,17H

TheEnd	DS 2

;  ITXT is the init message. Note that it is a BASIC statement
;  and must be terminated by a carriage return.

INtxt
	IF	FULLBASIC
	db	'PRINT "System 88 BASIC C04,'
	ELSEIF	PROTBASIC
	db	'PRINT "System 88 BASIC BC04,'
	ENDIF
	db	' 06/04/81. ",FREE(0)," bytes free."',CR

LDtxt	db	'LOAD,',0	; for file on command line
;
Bdirend	EQU	$
	END
