REM ****************************************************
1	PRINT CHR$(12),"M/L NEW  (12-16)"
REM	MAIL LIST PACKAGE			SEPTEMBER 1978
REM	MODIFIED BY CUSTOM ACCOUNTING, INC	AUGUST 1980
REM	MODIFIED BY BRIAN SMITH			SEPTEMBER 1980
REM	MODIFIED BY DON MOE			DECEMBER 1980
REM	MODIFIED BY FRANK ANDERSON		MAY 14, 1981
REM
REM	Copyright 1978,1979,1980 Interactive Products
REM	Corporation dba PolyMorphic Systems, Santa Barbara,
REM ****************************************************
REM	While we believe this program to be accurate
REM	PolyMorphic Systems assumes no liability, either
REM	explicit or implied, forthe use of this program.
REM	It is the responsibilty of the user to determine
REM	the accuracy and correctness of this program.
REM ****************************************************
REM	N E W   L I S T   P R O G R A M
REM ****************************************************
REM
REM ****************************************************
REM	M A I L   L I S T   F I L E S
REM ****************************************************
REM
REM	CONTROL FILE ... F$+"C"
REM
REM	The FIRST RECORD in the control file contains
REM	R1..............Number of entries allowed	4 chrs
REM	R2..............Number of entries entered	4 chrs
REM	R8..............Entries holding field names	4 chrs
REM	A5..............Alphabetical order field	4 chrs
REM	R(1)-R(6).......Field widths		    6 x 4 chrs
REM
REM	The SECOND RECORD contains
REM	R(7)-R(11)......Field widths		    5 x 4 chrs
REM
REM	The following entries are used to hold the alphabetical
REM	order of all entries in the Mail List File
REM
REM	600(max) recs ..10 entry numbers	10 x 4 chrs+CR
REM	8	 recs ..10 code counts		10 x 4 chrs+CR
REM
REM	MAIL LIST FILE..F$
REM
REM	The first R8 RECORDS contain the field titles held in
REM
REM	T$(11:10)........11 field titles	11 x 10 chrs
REM
REM	The next R1 RECORDS for name/address entry contain
REM
REM	R$(1:250)........Name/address etc entry	  max 250 chrs
REM	.................Carriage return	         1 CR
REM
REM ****************************************************
REM	V A R I A B L E S   U S E D
REM ****************************************************
REM
REM	FUNCTION VARIABLES
REM
REM	B0..............First array subscript in string entry
REM	C0..............Number of digits before decimal point
REM	D0..............Number of digits after decimal point
REM	F0..............Field containing decimal point
REM	I0,J0...........Loop variables
REM	K0..............Position if input string, Y$
REM	L0..............Length of input string, Y$
REM	M0..............ASC value of input variable
REM	N0..............Number being read or displayed
REM	P0..............Value to be poked in cursor position
REM	Q0..............Cursor position, found by PEEK
REM	U0..............Lower case to upper case variable
REM	X0..............X parameter for plot function
REM	Y0..............Y parameter for plot function
REM	W0..............Max width of input variable field
REM
REM	PROGRAM VARIABLES
REM
REM	A5..............Alphabetic order field
REM
REM	F$(1:34)........File to be created
REM	F...............Drive # on which file is to be created
REM
REM	I,J,K,L,M,N.....Loop variables and counters
REM	K1,K2...........Ditto
REM
REM	Q...............Question/comment number
REM	Q5..............Question reply value
REM	Q9..............Calculation variable
REM	Q$(9;43)........Questions and comments
REM
REM	S...............Number of sectors available
REM	S1..............Sectors used by control file
REM
REM	R(11)...........Entry field sizes
REM	R1..............Total number of entries allowed
REM	R2..............Total number of actual entries
REM	R8..............Number of entries holding field titles
REM	R9..............Length of each entry in characters
REM	R$(1:250).......Input entry area
REM
REM	D$(1:256).......Sector buffer for available sectors
REM
REM	T$(11:10).......Field titles
REM
REM	X$(250:1).......General string input area
REM
REM	Y$(1:50)........General purpose input/storage string
REM
REM ****************************************************
REM	D A T A   D E F I N I T I O N
REM ****************************************************
REM
10	DIM F$(1:34),Q$(9:43),R(11),R$(1:250),T$(250:1),X$(250:1),Y$(1:50),D$(1:256)
REM
REM	Questions/comments
REM
21	DATA "                          Is above correct?"
22	DATA "Range is  0-50 characters......RETURN"
23	DATA "Range is 10-250 characters...........RETURN"
24	DATA "Range is  1-11 ......................RETURN"
25	DATA "That field has no characters.........RETURN"
26	DATA "TAB ESC SPACE + . , are not allowed..RETURN"
27	DATA "                    Press RETURN to proceed"
28	DATA " error number generated....RETURN"
29	DATA "                                              "\MAT READ Q$
REM
REM ****************************************************
REM	M A I N   P R O G R A M
REM ****************************************************
REM
98	ON ESCAPE GOTO 65500
99	ON ERROR GOTO 65000
REM
REM	*********************
REM	Field names and sizes
REM	*********************
REM
1000	PRINT CHR$(12),
1010	PRINT "FIELD #",TAB(15),"FIELD NAME",TAB(31),
1020	PRINT "NO OF CHARACTERS     TOTAL"
1030	FOR I=1 TO 11\ PRINT %5I,I\ NEXT
1050	Q0=FNP(127)\ MAT X$=" "
1060	MAT R=0
REM
1100	FOR I=1 TO 11
1110	M=46-I*3\L=(I-1)*10+1
REM
REM	Names
REM
1200	L0=FNI(10,32,M)
1210	IF L0>0 THEN L0=FNA(L,10)
1220	IF L0=0 THEN X0=FNB(L,10,30,M)
REM
REM	Sizes
REM
1300	Z$=X$(L)
1305	IF Z$<=" " OR Z$>CHR$(127) THEN R(I)=0\L0=0\ GOTO 1330
1307	L0=FNI(2,88,M)
1310	IF L0>0 THEN R(I)=FNN(2,0)
1320	IF R(I)<0 OR R(I)>50 THEN Q=2\GOSUB 20000\GOTO 1300
1330	IF L0=0 THEN R(I)=FNO(R(I),86,M)
REM
1340	NEXT\ J=SUM(R)\J=FNO(J,102,13)\PLOT0,10,0
REM
REM	Alphabetical order field
REM
1350	PRINT "Alphabetize by field number",\POKE0,127
1400	L0=FNI(2,92,10)
1410	IF L0>0 THEN A5=FNN(2,0)
1420	IF A5<1 OR A5>11 THEN Q=4\GOSUB 20000\GOTO 1400
1430	IF R(A5)<1 THEN Q=5\GOSUB 20000\GOTO 1400
1440	IF L0=0 THEN A5=FNO(A5,90,10)
REM
1500	Q=1\GOSUB 20000\ON Q5 GOTO 1500,1100,1510
1510	IF J<10 OR J>250 THEN Q=3\GOSUB 20000\GOTO 1100
1520	MAT T$=X$
REM
REM	***************
REM	File-name entry
REM	***************
REM
REM	Titles
REM
1600	PRINT CHR$(12)\PRINT
1610	PRINT "New mail list name"
1620	PRINT "           Drive #"
1630	PRINT
1640	PRINT " Sectors available",CHR$(18),
1650	Q0=FNP(127)\MAT X$=" "
REM
REM	Name
REM
1700	L0=FNI(30,40,40)
1710	IF L0>0 THEN L0=FNA(1,30)\J=L0
1720	IF L0=0 THEN X0=FNB(1,30,38,40)
1730	FOR I=1 TO J\K=ASC(X$(I))
1740	IF K=9 OR K=27 OR K=32 OR K=43 OR K=44 OR K=46 THEN 1750 ELSE 1760
1750	Q=6\GOSUB 20000\EXIT 1700
1760	NEXT
REM
REM	Drive number
REM
1800	L0=FNI(1,40,37)
1810	IF L0>0 THEN F=FNN(1,0)
1820	IF F<1 OR F>7 THEN 1800
1830	IF L0=0 THEN F=FNO(F,38,37)
1840	Q=1\GOSUB 20000\ON Q5 GOTO 1840,1700,1900
REM
REM	Sectors available
REM
1900	ON ERROR GOTO 1980
1910	S=CALL(1,1,256*5+F,0,5000)
1920	Z=CALL(1,1,256+F,MEM(D$),0)
1930	S3=PEEK(MEM(D$)+13)+256*PEEK(MEM(D$)+14)
1940	S4=S-S3
1950	S4=FNO(S4,40,31)\GOTO 2000
1980	L0=FNI(3,40,31)
1985	IF L0>0 THEN S4=FNN(4,0)
1987	IF S4<5 OR S4>4928 THEN PRINT "Too few or too many!"\PAUSE 30\GOTO 1900
1990	S=0
REM
REM	Number of entries
REM
2000	R9=SUM(R)+1\ R8=INT((110+R9-.1)/R9)\ R1=((256*S4-410)/R9)-R8
2010	S1=INT((410+255.9+(INT((R1+9.9)/10)*41))/256)
2020	R1=INT((256*(S4-S1))/R9)-R8\ R7=R1*(R1<999)+999*(R1>999)
2025	IF S=0 THEN D$="Resulting" ELSE D$="Maximum possible"
2030	PLOT 0,3*8,0\ PRINT D$," total entries:",R7\Q=FNP(127)
2033	IF S=0 THEN R1=R7\GOTO 2040
2035	PLOT 0,3*7,0\ PRINT "Number of entries ",\Q=FNP(127)
2036	L0=FNI(3,40,21)
2037	IF L0>0 THEN R1=FNN(4,0)
2038	IF L0=0 THEN R1=R7\R1=FNO(R1,40,21)
2039	IF R1>R7 THEN 2036
2040	Q=1\ GOSUB 20000\ ON Q5 GOTO 2040,1900,5000
REM
REM	*****************
REM	New file creation
REM	*****************
REM
5000	F$=""\ F$=STR$(F) \F$="<"+MID$(F$,2,2)+">"
5010	FOR I=1 TO J\ F$=F$+X$(I)\ NEXT\ FILE:4,OPEN,F$,OUT
5020	PRINT CHR$(12),F$," is being created."\R9=R9-1
5030	FOR I=1 TO R8
5040	K1=1+(I-1)*R9\ J=I*R9\ K2=J*(J<=110)+110*(J>110)
5050	FOR K=K1 TO K2\PRINT:4,T$(K),\ NEXT\ PRINT:4,TAB(R9)
5060	NEXT
5070	R$=""\ FOR I=1 TO R9\ R$=R$+CHR$(32)\ NEXT
5080	FOR I=1 TO R1\ PRINT:4,R$\ NEXT\ FILE:4,CLOSE
REM
REM	*********************
REM	Control file creation
REM	*********************
REM
5200	F$=F$+"C"\FILE:4,OPEN,F$,OUT
5210	PRINT:4,%4I,R1,R2,R8,A5,R(1),R(2),R(3),R(4),R(5),R(6)
5220	PRINT:4,%4I,R(7),R(8),R(9),R(10),R(11),0,0,0,0,0
5230	J=INT((R1+9.9)/10)+8
5240	FOR I=1 TO J\PRINT:4,%4I,0,0,0,0,0,0,0,0,0,0\ NEXT
5250	FILE:4,CLOSE\ GOTO 65500
REM
REM ****************************************************
REM	U S E R   G U I D E
REM ****************************************************
REM
REM	Questions
REM
20000	Q9=0\ PLOT 0,5,0\ PRINT Q$(Q),\INPUT "",U$\ Q0=FNP(127)
20010	IF U$<>"" THEN Q9=FNU(ASC(U$))\ U$=CHR$(Q9)
20020	Q5=(Q9=78)+2*(Q9=89)+1\PLOT 0,5,0\ PRINT Q$(9)
20030	Q0=FNP(127)\ RETURN
REM
REM ****************************************************
REM	E R R O R   R O U T I N E
REM ****************************************************
REM
65000	Z=ERR
65010	IF Z<>1536 THEN 65100
65020	Z1=FNQ("That file already exists...RETURN")
65030	GOTO 1600
65100	IF Z<>258 THEN 65200
65110	Z1=FNQ("Preamble error -- Have you INITed data disk?")
65120	GOTO 65500
65200	IF Z=769 THEN 65205 ELSE 65210
65205	Z1=FNQ("Can't access that device")\GOTO 1600
65210	IF Z=257 THEN 65215 ELSE 65220
65215	Z1=FNQ("Not enough space on disk!")/GOTO 1600
65220	REM
65400	Z1=FNQ("Error"+STR$(Z)+" AT"+STR$(LINE))
65410	GOTO 65500
REM
REM ****************************************************
REM	E N D   O F   N E W - L I S T
REM ****************************************************
REM
65500	PRINT CHR$(12),"Returning to MENU..."
65510	Z=FNP(127)
65520	LINK "MLIST<MENU"
REM
REM ****************************************************
REM	F U N C T I O N S
REM ****************************************************
REM
REM	Lower to upper case
REM
50000	DEF FNU(U0)=U0-(U0>96)*(U0<123)*32
REM
REM	Input function for any variable
REM
50100	DEF FNI(W0,X0,Y0)
50110	PLOT X0,Y0,0\FOR I0=1 TO W0\PRINT "-",\NEXT\Q0=FNP(127)
50120	PLOT X0-2,Y0,0\INPUT1 " ",Y$\L0=LEN(Y$)
50130	P0=127*(L0>=W0)+173*(L0<W0)\Q0=FNP(P0)\RETURN L0
50140	FNEND
REM
REM	Cursor function
REM
50200	DEF FNP(P0)
50210	POKE 0,P0\Q0=PEEK(0)\RETURN Q0
50220	FNEND
REM
REM	Numeric vet for +ve numbers only
REM
50300	DEF FNN(C0,D0)
50310	N0=0\L0,F0=LEN(Y$)
50320	FOR J0=1 TO L0\J0$=MID$(Y$,J0,J0)\M0=ASC(J0$)
50330	IF M0=46 AND F0=L0 THEN F0=J0\GOTO 50360
50340	IF M0<48 OR M0>57 THEN N0=-1\EXIT 50370
50350	N0=(10*N0)+M0-48
50360	NEXT\N0=N0/10^(L0-F0)
50370	IF L0-F0>D0 OR F0-(L0>F0)>C0 THEN N0=-1
50380	RETURN N0
50390	FNEND
REM
REM	Numeric diplay
REM
50400	DEF FNO(N0,X0,Y0)
50410	PLOT X0,Y0,0\PRINT N0,\Q0=FNP(127)\X0=MOD((Q0-6144),64)
50420	FOR J0=X0+1 TO 63\PRINT " ",\ NEXT\ Q0=FNP(127)\ RETURN N0
50430	FNEND
REM
REM	String assignment
REM
50500	DEFFNA(B0,W0)
50510	L0=(L0<W0)*L0+(L0>=W0)*W0
50520	FOR J0=B0 TO B0+L0-1\ K0=J0-B0+1\ X$(J0)=MID$(Y$,K0,K0)
50530	IF X$(J0)<" " THEN X$(J0)=" "
50540	NEXT\ IF L0=W0 OR W0=1 THEN 50560
50550	FOR J0=B0+L0 TO B0+W0-1\X$(J0)=CHR$(160)\NEXT
50560	RETURN L0
50570	FNEND
REM
REM	String display
REM
50600	DEF FNB(B0,W0,X0,Y0)
50610	PLOT X0,Y0,0\PRINT" ",
50620	FOR J0=B0 TO B0+W0-1\PRINTX$(J0),\NEXT
50630	FOR J0=X0/2+W0+2 TO 63\PRINT" ",\NEXT\Q0=FNP(127)
50640	RETURN X0
50650	FNEND
REM
REM	FNQ -- QUESTIONS
REM
50700	DEF FNQ(Z$)
50710	PLOT 0,8,0\ PRINT\ PRINT TAB(40-LEN(Z$)),Z$,
50720	INPUT " ",U$\ Q0=FNP(127)\ Q9=0
50730	IF U$<>"" THEN Q9=FNU(ASC(U$))\ U$=CHR$(Q9)
50740	PLOT 0,5,0,\ OUT 1,CHR$(24) \ Q0=FNP(127)
50750	RETURN (Q9=78)+2*(Q9=89)+1
50760	FNEND
