;********************************************************
;*							*
;*			Screen Dumper			*
;*							*
;*	Version 0.0			Brian Smith	*
;*							*
;*							*
;*							*
;*							*
;********************************************************
;
	REFS	SYSTEM
	REF

	IF 	USERS=1
Moven	EQU	100H
PLACE	EQU	0FF00H
	ELSE
PLACE	EQU	0DD00H
	ENDIF

CTRLU	EQU	16H	; Control U.
CR	EQU	13
FF	EQU	12

	ORG	USER
	IDNT	$,$

	JMP	START
	RET			; No reenter allowed.

INSTALLED db	'Screen printer installed!',CR,0

START	LXI	H,CODE
	LXI	D,PLACE
	LXI	B,-CODELEN
	CALL	Moven		; Move the code into place.
	DI
	MVI	A,CTRLU
	STA	UCHR		; Set up character
	LXI	H,PLACE
	SHLD	UVEC		; and vector.
	LXI	H,PLACE
	DCX	H
	SHLD	MEMTOP
	EI
	LXI	H,INSTALLED
	JMP	Msg		; Return printing message.
CODE

	LOC	PLACE
	LDA	BUSY		; Look at busy flag.
	ORA	A
	JNZ	Ioret		; Ignore if busy.
	CMA			; set no-zero
	STA	BUSY		; in BUSY flag.
	LDA	SCRHM
	MOV	H,A
	MVI	L,0		; Screen address in HL.
	MVI	B,16
	MVI	A,FF
	CALL	WH7
LINE	MVI	C,64
	MVI	A,CR
	CALL	WH7
NOLINE	MOV	A,M
	MOV	D,A
	ANI	80H
	JZ	NEXT
	MOV	A,D
	ANI	7FH
	CPI	7FH
	JZ	NEXT
	CALL	WH7
NEXT	INX	H
	DCR	C
	JNZ	NOLINE
	DCR	B
	JNZ	LINE
	XRA	A
	STA	BUSY
	JMP	Ioret

BUSY	DB	0
CODELEN	EQU	$-PLACE
	END
