;********************************************************
;*							*
;*		Macro-Assembler				*
;*							*
;*	Version 5.1			Roger L. Deran	*
;*	06/10/81					*
;*							*
;*	Copyright (c) 1980, Interactive Products	*
;*  Corporation dba PolyMorphic Systems 460 Ward Dr.	*
;*  Santa Barbara, CA  93111				*
;*							*
;********************************************************
;
FALSE	EQU	0
TRUE	EQU	NOT FALSE
M88ASM	EQU	TRUE
M86ASM	EQU	FALSE
M65ASM	EQU	FALSE
M89ASM	EQU	FALSE
MACROS	EQU	TRUE
REFSDEFS EQU	TRUE
;
;**** EQUATE SECTION ****
;
;	ASCII characters
;
NUL	EQU	0
BS	EQU	08H
TAB	EQU	09H
LF	EQU	0AH
VT	EQU	0BH
FF	EQU	0CH
CR	EQU	0DH
CTLW	EQU	17H
CTLX	EQU	18H
CTLY	EQU	19H
CTLZ	EQU	1AH
ESC	EQU	1BH
ALTMODE EQU	7DH
SPACE	EQU	' '
RB	EQU	7FH
DEL	EQU	RB
;
;	System references.
;
	REFS	SYSTEM
;
; 4.0 Monitor stuff.
;
	REF	WH0		;Operator's keyboard.
	REF	WH1		;Operator's  CRT.
	REF	WH7		;Printer wormhole.
;
;	Root stuff
;
	REF	USER
	REF	DEVMASK
	REF	MEMTOP
	REF	CMND
	REF	Warm
	REF	Dio
	REF	Msg
	REF	Err
	REF	Ovrto
	REF	Gover
	REF	Rlwe
	REF	Fold
	REF	Flip
	REF	USERS

	IF	USERS=2
	REF	Devlock
	REF	sett
	REF	mung
	REF	clrt
	REF	Gfid
	ENDIF
;

gfid	MACRO
	IF	USERS=1
#L	CALL	Gover
	DB	'Gfid'
	ELSEIF	USERS=2
#L	CALL	Gfid
	ENDIF
	ENDM
	
	MACLIST 0		;No macro expansions.
