	ROM Dio support
;	1/22/80		RTM 	Rom support
;	1/28/80		RTM 	Cleanups, new roms
;	2/4/80		RTM	Rip out a DI in Unlock
;	2/6/80		RTM	One size fits all roms...
;	2/8/80		RTM	Dont check kbd stat if PMASK 0
;	2/18/80		RTM	RTC bug- support 0C00 ticker
;	2/22/80		RTM	Devlock hooks
;	2/25/80		RTM	Devlock support
;	2/27/80		RTM	Better skm support
;	3/6/80		RTM	Lock on Look path
;	3/13/80		RTM	Bug in Cfird path
;	3/18/80		RTM	Note bits in BHA...
;	3/20/80		RTM	Break up large i/o's
;	3/29/80		RTM	Keyboard works in SOLO mode...
;	4/3/80		RTM	Get and free printer shit
;	4/29/80		RTM	Redo clock handling
;	5/15/80		RTM	Clock zero bugs!
;	5/28/80		BFS	gfid look vector
;	5/29/80		Staff	GFLOCK moved from Gfid and put
;				after jump vectors. Gfid lock
;				code changed to fix Gfid boot
;				problem.
;	5/30/80		JDW	Add REFS to enter/leave macros
;				for GFLOCK
;	5/30/80		BFS	Add side door to Runr for
;				GfLoad
;	7/8/80		RTM	Enter stuffs lock with user #
;				Kbev exit path checks to see if
;				Gfid is locked, and doesn't
;				allow aborts if locked (sigh)
;	11/05/80	BFS	Gave Vti its own pop pop pop
;				pop ret without ei.  It's only
;				two more bytes and it works!
;	1/9/81		FEA	Added volume manager support
;				and hard disk support to root.
;	01/30/81	BFS	Added CHUNK ref and associated
;				stuff in doesio.
;
	PAGE
	MACLIST	maclist
	REFS	SYSTEM
	REF	enter
	REF	leave
	REF	db
	REF	dw
	REF	rorg
	REF	rds
	REF	ralign
	REF	ALIGN
	REF	BRGEN
	REF	PHANTOM
	REF	giveup
	REF	ioret
	REF	rddef
	REF	dequ
	REF	overto
	REF	gover
	REF	overlay
	REF	userpgm
	REF	EIC
	REF	EERR
	REF	DBARF
	REF	DEVMASK
	REF	SRA1
	REF	SRA2
	REF	SRA3
	REF	SRA4
	REF	SRA5
	REF	SRA7
	REF	SRA7I
	REF	BOOTVOL
	REF	BRG
	REF	IOIP
	REF	USP
	REF	UTIME
	REF	LOCK
	REF	WAKEUP
	REF	SCEND
	REF	SCRHM
	REF	POS
	REF	WH0
	REF	WH1
	REF	WH2
	REF	WH3
	REF	WH4
	REF	WH5
	REF	WH6
	REF	WH7
	REF	WH8
	REF	WH9
	REF	KBIP
	REF	KBIG
	REF	KBEX
	REF	CMND
	REF	CMPTR
	REF	CMDF
	REF	CMDD
	REF	CMDP
	REF	CMDA
	REF	CMDN
	REF	SBRK
	REF	PVEC
	REF	UVEC
	REF	UBRK
	REF	SCHR
	REF	UCHR
	REF	DONT
	REF	OVNM
	REF	OVHL
	REF	OVDE
	REF	OVBC
	REF	OVPSW
	REF	SYSRES
	REF	NFDIR
	REF	NFCK
	REF	ONCE
	REF	EFLG1
	REF	EFLG2
	REF	ERROR
	REF	LERR
	REF	FILE
	REF	USRNAME
	REF	CHUNK
	REF	CBUF
	REF	OVRLY
	REF	OVENT
	REF	SBUF1
	REF	KBUF
	REF	MUNGP
	REF	USER
	REF	Dio
	REF	KBMODE1
	REF	KBMODE2
	REF	VCBTAB
	REF	DioA
	REF	DioHL
	REF	DioDrv
	REF	DioDn
	REF	DioBsy
	REF	BUSIES
	REF	DRVADTAB
	REF	SUWH0
	REF	SUWH1
	REF	SUWH2
	REF	SUWH3
	REF	SUWH4
	REF	SUWH5
	REF	SUWH6
	REF	SUWH7
	REF	SUWH8
	REF	SUWH9
	REF	sett
	REF	clrt
	REF	setp
	REF	clrp
	REF	rd
	REF	wrt
	REF	cmdf
	REF	mung

	PAGE
; local macros

vect	MACRO
V#L	EQU	$
	JMP	#L
	ENDM

savesp	MACRO
#L	LXI	H,0
	DAD	SP
	SHLD	USP
	ENDM
; Local equates

CR	EQU	0DH		; carriage return
CTLW	EQU	17H		; control W
CTLX	EQU	18H		; control X
CTLY	EQU	19H		; control Y
TAB	EQU	9		; horizontal tab
DEL	EQU	7FH		; delete
FF	EQU	0CH		; Form Feed. Clear and home up
VT	EQU	0BH		; Vertical tab.

ROM	EQU	0		; we're not the boot roms...

STACK	EQU	0E000H		; stack starts here!

; We run two users. They are Dum (Tweedledum) and Dee.
; Here's where their video boards, and keyboard ports live:

Kbd	EQU	18H		; keyboard data
Video	EQU	Kbd*256		; VTI address
	PAGE

; NOTE: we use a funny vect macro so that this table can be built
; from editing the vermin source file.... (I'm lazy)

	ORG	0E000H		; common memory
	IDNT	$,$

Vectors	EQU	$

; IMPORTANT NOTE:
;	ALL references to these routines in the resident
;	portion of the system should refer to the "V"name
;	form- i.e. CALL Look should be CALL VLook. That way,
;	if something wants to rip off a vector, it will get
;	all the things that use the vector...

Cold	vect			; 00 cold start
Warm	vect			; 03 warm start
Msg	JMP	040CH		; 06 display message
Pmsg	vect			; 09 print message
Err	vect			; 0C error bailout
Ovrto	vect			; 0F overlay call
Gover	vect			; 12 overlay call
Rtn	vect			; 15 overlay return
Killi	vect			; 18 kill input, cmdf
Flush	vect			; 1B flush typeahead
Look	vect			; 1E look up file
Runr	vect			; 21 run a program
Rlwe	vect			; 24 read line with editing
Fold	JMP	042AH		; 27 fold lc to UC
Flip	JMP	042DH		; 2A flip lc and uc
Ckdr	JMP	0433H		; 2D checksum directory
Iexec	vect			; 30 interrupt level Exec
Show	vect			; 33 show string on screen
Vprint	vect			; 36 print string to printer
Flipem	vect			; 39 Flip to other user
Giveup	vect			; 3C give up processor
Ticker	vect			; 3F clock tick handler
Gfid	vect			; 42 Get file id 
Deout	vect			; 45 display de in hex
Lock	vect			; 48 Lock processor
Unlock	vect			; 4B Unlock processor
Enter	vect			; 4E Enter critical region
Leave	vect			; 51 Leave critical region
Vmgr	vect			; 54 Volume manager functions
Vti	vect			; 57 Display driver
Byte	vect			; 5A display byte on screen
PMASK	DB	0      		; 5D Swap mask
USTATS	DB	0		; 5E Usart status
BHA	DB	0		; 5F Bob's Hairy A...
Mtos	vect			; 60 Move to other space
Mfos	vect			; 63 Move from other space
Ioret	JMP	64H		; 66 Interrupt return
Moven	vect			; 69 Move, bc negative
Move	vect			; 6C Move, bc positive
Devlock	vect			; 6F Device locking
Gdfp	vect			; 72 Get the f... printer
Fdfp	vect			; 75 Free the f... printer
Fpanel	JMP	PANEL		; 78 Front panel vector
gLook	vect			; 7B gfid look vector
GFLOCK	DS	1		; Gfid semaphore!

; Bit assignments in BHA (all internal scuzz!)
;
;	80H	YAK enabled if on
;	40H	We've got two users (for SET SOLO)
;	20H	WAIT mode enabled (set WAIT)

	PAGE
; Clock processing, giving up the processor, and changing users
; Ticker is entered by the 60hz clock interrupt. By the time we
; get here, the context has been saved, but we must reenable
; the clock interrupt. We are hooked up through single user
; wormhole 8 in the one size fits all roms.

Ticker	OUT	8		; re enable interrupt
	LHLD	0C00H
	INX	H
	SHLD	0C00H		; tick this for everybody.

Tick0	LXI	H,0
	MOV	B,L		; remember diddling current u
	DAD	SP
	SHLD	USP		; user now parked.

Tick1	LXI	H,UTIME
	MVI	C,4		; diddle clock for user
Tick2	INR	M
	JNZ	Tick3		; jmp/no overflow.
	INX	H
	DCR	C		; see if all 0000
	JNZ	Tick2		; jmp/not yet.

; User clock went to 0000. Build environment to invoke WAKEUP
; routine next time we run 'em.

	LHLD	USP
	SPHL			; insure right stack loaded.
	LHLD	WAKEUP		; the vector
	PUSH	H		; new PC
	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	LXI	H,0
	DAD	SP
	SHLD	USP		; all done.

; End of clock processing. See if we've diddled both clocks,
; and split thru Ioret when we have. B will be nonzero if we've
; done both users.

Tick3	MOV	A,B
	ORA	A		; done both yet?
	JNZ	Tick4		; jmp/yup, scram.
	LDA	PMASK		; phantom mask
	ORA	A
	JZ	Flip1		; jmp/nobody else to do!
	MOV	B,A		; remember doing other guy.
	LDA	BRG
	XRA	B
	OUT	BRGEN		; ***** SWAP *****
	JMP	Tick1		; go do other one.

Tick4	LDA	BRG
	OUT	BRGEN		; insure mapped to first guy
	LXI	H,LOCK
	MOV	A,M		; software lock set?
	ORA	A
	JZ	Flip1		; jmp/not locked.
	MVI	M,2		; say quantum overrun
	LHLD	USP
	SPHL			; insure we got his stack!
	JMP	Ioret		; and split.
	PAGE
; Giveup is entered to give up the processor. We disable, save
; the environment, and fall into Flipem to run the other user.

Giveup	DI
	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H		; stash regs.
	XRA	A
	STA	LOCK		; insure not locked!

; Flipem flips to the other process. We first stash this user's
; stack pointer at USP, and then flip the PHANTOM bit of the
; baud rate generator, load the new SP from USP, and return
; thru Ioret to load the new context

; NOTE:
; If we are running one user only (only one 48k board) we
; STOMP on Flip1 to turn it into an EI/RET pair (ooch!)

Flipem	DI			; insurance
	savesp			; save the stack pointer
Flip1	LDA	PMASK		; get phantom mask (or split)
	MOV	B,A		; move over here.
	LDA	BRG		; old baud rate gen contents
	XRA	B		; flip the PHANTOM bit
	OUT	BRGEN		; do it
	STA	BRG		; mark it done
	LHLD	USP		; new SP
	SPHL
	JMP	Ioret

; Ssint is a neet little hack that lets both users have
; the single step or rst 7 vector to themselves. Ssint is
; hooked through SRA7I.

Ssint	LHLD	SRA7
	PCHL			; roar off!
	PAGE
; Mtos is move to other space. The implementation is a
; genuine HACK. I do not appologise. RTM.

; Enter with:
;	HL = destination address in OTHER user
;	DE = source address in YOUR space
;	BC = positive count of bytes to move.

Mtos	DI			; screw you.

Mtos1	PUSH	B
	LDAX	D
	MOV	C,A		; get byte
	LDA	BRG
	MOV	B,A
	XRI	PHANTOM
	OUT	BRGEN
	MOV	M,C		; put byte
	MOV	A,B
	OUT	BRGEN
	POP	B
	INX	H
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	Mtos1
	EI			; give the guy a break.
	RET			; disgusting.
	PAGE
; Mfos is move from other space. The implementation is a
; genuine HACK. I do not appologise. RTM.

; Enter with:
;	HL = destination address in YOUR space
;	DE = source address in OTHER space
;	BC = positive count of bytes to move.

Mfos	DI			; screw you.

Mfos1	PUSH	B
	LDA	BRG
	MOV	B,A
	XRI	PHANTOM
	OUT	BRGEN		; swap to other user
	LDAX	D
	MOV	C,A		; get byte
	MOV	A,B
	OUT	BRGEN		; swap back to original user
	MOV	M,C		; put byte
	POP	B
	INX	H
	INX	D
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	Mfos1
	EI			; Give the guy a break.
	RET			; disgusting.
	PAGE
; Vshow function. Called most commonly by show macro, it shows
; the data following the call, until a 00 byte is hit, on the
; display screen.

Show	XTHL			; save HL, get return address

Vshow1	MOV	A,M		; pick up a byte
	ORA	A
	JZ	Vshow2		; jmp/done
	CALL	WH1		; display it
	INX	H
	JMP	Vshow1

Vshow2	XTHL
	RET			; restore HL and split.

; Vprint is similar to the Vshow function, except that it goes
; through WH7 to the printer.

Vprint	XTHL

Vprint1	MOV	A,M
	ORA	A
	JZ	Vshow2
	CALL	WH7
	INX	H
	JMP	Vprint1
	PAGE
; Pmsg sends a message to the printer

Pmsg	MOV	A,M
	ORA	A
	RZ
	CALL	WH7
	INX	H
	JMP	Pmsg

; Deout displays contents of DE in hex on screen (thru WH1)

Deout	MOV	A,D
	CALL	Byte
	MOV	A,E
Byte	PUSH	PSW
	RRC
	RRC
	RRC
	RRC
	CALL	Byte1
	POP	PSW
Byte1	ANI	15
	ADI	90H
	DAA
	ACI	40H
	DAA
	JMP	WH1
	PAGE
; Lock and Unlock provide protection against slicing.

Lock	PUSH	PSW
	MVI	A,1
	STA	LOCK
	POP	PSW
	RET			; set lock and return

Unlock	PUSH	H		; save HL
	LXI	H,LOCK
	MOV	A,M		; get lock
	MVI	M,0		; clear it
	CPI	2
	POP	H		; did it mark quan overrun?
	JZ	VGiveup		; give up if so!
	RET			; else split.

; Enter and Leave are the semaphore management routines
; for the semaphore pointed to by HL

Enterw	giveup

Enter	DI
	MOV	A,M		; get value of semaphore
	ORA	A		; see if 00
	JNZ	Enterw		; wait if nonzero
	LDA	BRG		; get user #
	ORI	80H		; insure nonzero
	MOV	M,A		; grab semaphore
	XRA	A		; ret Z set
	EI			; Give the guy a break.
	RET

; Leave leaves the section and clears the semaphore pointed
; to by HL

; nb- for the future, we might want to see if we had the
; semaphore we're about to give up! The magic question
; is, what do we do if it wasn't us?

Leave	MVI	M,0		; easy way out.
	EI			; clear and enable
	RET			; bye.
	PAGE

; Warm is also the job-step entry point. It invokes the
; Exec off the disk.

Warm	LXI	SP,STACK	; reset that.
	CALL	VGover
	DB	'Exec'		; invoke the Exec.
	JMP	VWarm		; that's the main loop.

; For invoking the Exec in various places

Iexec	CALL	VOvrto
	DB	'Exec'
	JMP	Ioret		; do interrupt return!
	PAGE
; KILLI is called to kill typeahead. This entry also
; aborts command files, if in progress. The entry FLUSH
; just flushes the keyboard buffer. It is called as part
; of Init to set up the buffer pointers.

Killi	LDA	CMDF		; see if in command file
	ORA	A
	JZ	Flush		; jmp/nope, we're ok.

	PUSH	D
	PUSH	B
	MVI	B,0C1H		; clear perm cmdf
	CALL	Cucfd
	POP	B
	POP	D
	XRA	A
	STA	CMDD		; clear command dev
	STA	CMDF		; clear command file
	PUSH	H
	LXI	H,Ecma
	CALL	Msg		; give 'em the message
	DI
	DB	21H		; skip DI and PUSH H

; Flush is entered just to flush the typeahead buffer.

Flush	DI
	PUSH	H
	LXI	H,KBUF+63
	SHLD	KBIP		; reset the ring pointers
	SHLD	KBIG
	POP	H
Return	RET			; return DISABLED!?????

Ecma	db	'(Cmdf abort)',0

; Clear out command file device

Cucfd	LDA	CMDD		; device #
	MOV	C,A		; in C
	ORA	A
	JNZ	VDevlock	; call Devlock if needed
	RET			; then split.
	PAGE
; Rlwe is read line with editing. It prompts the user by
; Msg'ing the string pointed to by DE, and then reads into the
; buffer pointed to by HL. Max num of chrs is in C, and B
; contains a flag that notes if we are to echo the termination
; chr (=0), or not (<>0). On exit, A contains the terminator
; character, B contains line length, HL points to last
; chr in buffer. We activate on CR, ESC, or buffer full.

Rlwe	PUSH	D
	PUSH	H
	PUSH	B
	XCHG
	CALL	Msg		; print the prompt
	XCHG
	MVI	B,0		; B will be chr counter
Rlgc	CALL	WH0		; get a character
	CPI	DEL
	JZ	Rldel		; jmp/we got a del.
	CPI	CTLX
	JZ	Rlcx		; jmp/cancel line
	CPI	CTLW
	JZ	Rlcw		; jmp/delete a word

	MOV	M,A		; not special, put in buffer.
	INX	H
	INR	B		; bump ptr, bump count
	CPI	CR
	JZ	Rlx		; jmp/time to go.
	CALL	WH1		; Echo the thing.
	CPI	TAB		; did we just insert a tab?
	JNZ	Rlok		; jmp/nope, we're cool.

; Funny the screen for the tab we just inserted. We do that
; (put a 3F in the screen) so that we can tell where a tab
; expansion ends on the screen for deleting tabs......

	PUSH	H
	LHLD	POS
	DCX	H
	MVI	M,3FH		; poke...helps us delete 'em.
	POP	H
Rlok	MOV	A,B
	CMP	C		; did we fill buffer yet?
	JNZ	Rlgc		; jmp/nope, pick up another.

; Time to go. Exit with count in B, terminator in A

Rlx	MOV	E,B		; count
	POP	B
	MOV	A,B
	ORA	A
	DCX	H
	MOV	A,M		; terminator
	CZ	WH1		; echo/dont, whatever's right.
	MOV	B,E
	XTHL
Rhd	EI			; for use by DIO returning!
	POP	H		; end pointer
	POP	D		; junk
	RET			; nice doing business with you.

; We got a DEL. Unless we're at the front, back up.

Rldel	CALL	Rldlt
	JMP	Rlgc		; make it a subroutine.

; Subroutine that deletes things. As Ed Bryan told me,
; try to put all your worms in one basket....

Rldlt	MOV	A,B
	ORA	A
	RZ			; if empty, punt.
	DCR	B
	DCX	H
	MOV	A,M
	CPI	TAB		; is it? (Hope not.)
	JZ	Rlddl		; jmp/yup, go croak it.
Rld1	CPI	' '		; less than a space?
	RC			; split if does not use space.

; Delete something from screen. Note that we will bump off
; preceeding tab fill characters (7F's) if found, but WILL NOT
; wrap back to previous line.

Rlddl	PUSH	H		; save.
Rldd	MVI	A,DEL
	CALL	WH1		; bug off the 3F, at least.
	LHLD	POS
	MOV	A,L
	ANI	63		; at beginning of line?
	JZ	Rlde		; jmp/yes, split!
	DCX	H
	MOV	A,M
	CPI	7FH		; tab fill chr?
	JZ	Rldd		; jmp/yes, gronk it.
Rlde	POP	H		; restore goodies
	RET			; and vanish.

; We got a control-X, delete the line to this point.

Rlcx	MOV	A,B
	ORA	A
	JZ	Rlgc		; jmp/nuts to you.
	CALL	Rldlt		; go delete something.
	JMP	Rlcx		; see if we're done.

; Rlcw says we have a control-W, delete the last word.
; A word is defined as a string of <a-z,A-Z,0-9>

Rlcw	CALL	Rldlt		; delete at least one thing
Rlcw1	MOV	A,B
	ORA	A
	JZ	Rlgc		; jmp/all gone.
	DCX	H
	MOV	A,M
	INX	H		; peek at prev. character
	CPI	'0'		; now test for breaks
	JC	Rlgc		; less than 0 is a break
	CPI	'9'+1
	JC	Rlcw		; 0-9 we delete
	ANI	5FH		; lump lower and upper case
	CPI	'A'
	JC	Rlgc		; between 9 and A is break
	CPI	'Z'+1
	JC	Rlcw		; delete A-Z
	JMP	Rlgc
	PAGE
; Handle processing of interrupt characters. When we have an
 the
; user's stack after picking up USP, and update USP so that
; we'll enter the code the next time we run the user.

Kbsb	LDA	EFLG1		; is the Exec running?
	ANI	EIC
	JNZ	Kbxx		; jmp/yes, don't do it!
	INR	A
	STA	SBRK		; set control-Y flag non-zero
	LHLD	PVEC		; where is the wizard???
Kbev	LDA	DONT		; Do we or don't we do it?
	ORA	A
	JNZ	Kbxx		; jmp/better not. Something going on.

; Let's see if Gfid is locked. If it is, and we've got an
; interrupt from the user that has it locked, ignore 'em!

	LDA	GFLOCK
	ORA	A		; locked it is?
	JZ	Kbxy		; jmp/no.
	ANI	PHANTOM		; by which user locked?
	JZ	Kbu0		; by user 0
Kbu1	LDA	BRG		; user 1 has lock.
	XRA	B		; does user 1 want goose?
	JZ	Kbxy		; jmp/nope, allow goose!
	JMP	Kbxx		; locked, ignore goose!

Kbu0	LDA	BRG
	XRA	B		; does user 0 want goose?
	JNZ	Kbxy		; jmp/nope, allow it.
	JMP	Kbxx		; ignore goose for locked user

; Load user's stack pointer so we can build interrupt
; environment on the right stack, kill typeahead.

Kbxy	XCHG			; addr to DE
	LHLD	USP		; get user stack pointer
	SPHL			; and load that in

	PUSH	D		; the PC
	LXI	H,VKilli	; but go through Killi first!
	PUSH	H		; the first PC
	LXI	H,0
	PUSH	PSW		; PSW
	PUSH	B		; B
	PUSH	D		; D
	PUSH	H		; H
	DAD	SP		; and update saved SP in USP
	SHLD	USP
	JMP	Kbxx		; then split.

Kbub	LHLD	UVEC		; where do we go from here?
	STA	UBRK		; set user break has occurred
	JMP	Kbev		; Go to the right place.

Kbsp	LXI	H,Fpanel	; where we would like to go
	JMP	Kbev		; Zoom off....
	PAGE
; Kbint is the interrupt handler for keyboards. We grab the
; character, and ignore the shit out of nulls. If PMASK=0, we
; don't check the status port, as old systems don't have 'em!

Kbint	savesp			; save this guy's SP

	MVI	B,0		; mark checking current guy
	LDA	BHA		; see if we're in SOLO mode
	ANI	40H		; this is SOLO bit
	JNZ	Kbint1		; jmp/yes, solo mode.
	LDA	PMASK
	ORA	A		; are we single user?
	JZ	Kbgot		; jmp/yup, look at keyboard!
Kbint1	IN	Kbd+1		; check current keyboard
	RAR
	JNC	Kbgot		; got one from current user

; Now we must flip the map and check the other keyboard.

Kbdee	MVI	B,PHANTOM	; mark we're the other guy.
	LDA	BRG		; get current contents
	XRA	B		; flip PHANTOM bit
	OUT	BRGEN		; flip to other user

	IN	Kbd+1
	RAR
	JNC	Kbgot		; jmp/got one from other guy

; Exit from keyboard interrupt. We insure we're mapped to
; the correct user, and pick up the SP again, as we may
; have built an interrupt environment on it.

Kbxx	LDA	BHA
	ANI	40H		; SOLO set in BHA?
	JNZ	Kbxx1		; jmp/check both kbds.

	LDA	PMASK		; are we single user then?
	ORA	A
	JZ	Ioret		; jmp/nobody else to check!
Kbxx1	MOV	A,B
	ORA	A		; did we check the other guy?
	JZ	Kbdee		; jmp/nope, go check him.
Kbxxx	LDA	BRG
	OUT	BRGEN		; flip back to original guy
	LHLD	USP		; get his stack pointer
	SPHL			; restore it
	JMP	Ioret		; and scram.

; Special case! We got a keyboard interrupt, and it wasn't
; from the current user's keyboard, and PMASK has a ZERO in it!
; Flip to other keyboard (may not be there!), INPUT, split!

Kbguk	LDA	BRG
	XRI	PHANTOM
	OUT	BRGEN		; *** SWAP ***
	IN	Kbd		; should clear interrupt!
	JMP	Kbxxx		; scram.

; We have a character from the keyboard we're now mapped to.
; Note that B has either 00 or PHANTOM to note if we're the
; current running user, or have flipped the map.

Kbgot	IN	Kbd		; get the chr
	ORA	A
	JZ	Kbxx		; scram if 00

; Now see if single keyboard mode is enabled, by checking
; KBMODE1 to be nonzero

	MOV	C,A		; stash key over here
	LDA	KBMODE1
	ORA	A		; in single mode?
	JZ	Kbgot1		; jmp/nope, regular mode
	MOV	A,C		; put chr back in A

; See if it's a roman numeral key (I or II) to select
; single keyboard mode.

	CPI	28		; single kbd?
	JZ	Kbone		; jmp/yup
	CPI	29
	JNZ	Kbgot0		; jmp/not for us.

; Set up single keyboard mode.

Kbone	CPI	28		; select 0 or 1?
	MVI	A,0
	JZ	Kbone1		; jmp/it's 00
	MVI	A,PHANTOM	; else it's one.
Kbone1	STA	KBMODE2
	JMP	Kbxx		; split.

; Check KBMODE1 to see if we've been put into one keyboard
; mode on the system.

Kbgot0	MOV	C,A		; move key to here.
	LDA	KBMODE1
	ORA	A
	JZ	Kbgot1		; jmp/nope, normal mode!

; We are in single keyboard mode. KBMODE2 says where the
; keystrokes are supposed to go.

	LDA	BRG
	ANI	NOT PHANTOM
	MOV	E,A		; put over here for a while
	LDA	KBMODE2
	ORA	E
	OUT	BRGEN		; flip to proper user to store

Kbgot1	MOV	A,C
	CPI	CTLY		; system break?
	JZ	Kbsb		; jmp/lurch off if so.

	LDA	SCHR
	CMP	C		; system panic?
	JZ	Kbsp		; jmp/yup, give 'em the panel.

	LDA	UCHR
	CMP	C		; user interrupt??
	JZ	Kbub		; jmp/go do it then.

; Not an interrupt character. Look at putting it into the
; user's ring buffer.

	LHLD	KBIP
	MOV	M,C		; poke into the buffer
	DCR	L		; dink the pointer.
	MVI	A,(KBUF-1) AND 255	; See if wraparound
	CMP	L		; happened to the pointer
	JNZ	Kbi1		; jmp/nope.
	MVI	L,(KBUF+63) AND 255 	; reset pointer.
Kbi1	LDA	KBIG		; now see if full
	CMP	L
	JZ	Kbxx		; jmp/yup, drop on the floor.
	SHLD	KBIP		; else save the pointer
	JMP	Kbxx
	PAGE
; Cin is the input routine we hook up to wormhole 0 (WH0). 
; We can't clobber anything but A in here. We check
; to see if we are in command file mode, and bail into that
; for command file reads (Cfin). If not, we look at the buffer
; for a character. If nothing there, we loop thru WAIT until
; a character arrives. Note that we do a good bit of the
; processing disabled, as the keyboard buffer pointers are
; interrupt alterable- KBIP by interrupt for characters, and
; KBIG by Killi.

Cwt	POP	H		; get saved thing off the stack
	giveup			; give up for a while.

Cin	LDA	CMDF		; check command file flag
	ORA	A
	JNZ	Cfin		; jmp/go get from Cfin.
	DI			; look at keyboard
	PUSH	H
	LHLD	KBIG		; get pointer
	LDA	KBIP		; put pointer
	CMP	L		; anything there?
	JZ	Cwt		; jmp/nope, wait for something.

	MOV	A,M		; pick up chr
	PUSH	PSW		; stuff away
	DCR	L
	MVI	A,(KBUF-1) AND 255
	CMP	L		; check for wraparound
	JNZ	Cin1		; jmp/nope
	MVI	L,(KBUF+63) AND 255
Cin1	SHLD	KBIG		; save new get pointer
	POP	PSW		; chr
	EI			; let the world in
	LHLD	KBEX		; post processor hookup
	XTHL			; get HL back, addr to stack
	RET			; call post processor....
	PAGE
; Cfin is the entry for command file reads. We use CMDP to
; pick a character out of the buffer. If CMDP on entry points 
; past the buffer, we go to Cfinr to try to get another sector.

Cfin	PUSH	H		; for pointers, etc.
Cfin1	LHLD	CMDP		; don't think I need to disable
	MVI	A,(CBUF+256)/256 ; watch out for this kludge!!!
	CMP	H		; do we need to read??
	JZ	Cfinr		; jmp/looks like it.
	MOV	A,M		; if not, pick up chr
	INX	H		; bump the pointer
	SHLD	CMDP		; save it
	ORA	A
	JZ	Cfin1		; ignore nulls....
	POP	H
	RET			; and return.

; We need another block. Check CMDN first- if zero, that was
; the last one; clean up command file mode and leap into CIN.

Cfinr	LHLD	CMDN
	MOV	A,H
	ORA	A
	JNZ	Cfird		; jmp/bummer- go read.
	ORA	L
	JNZ	Cfird		; jmp/go read.

; Clean up command file mode, and go to the user.

	PUSH	D
	PUSH	B
	MVI	B,0C1H		; clear perm cmdf on device
	CALL	Cucfd		; if it's nonzero, of course...
	POP	B
	POP	D
	XRA	A
	STA	CMDF		; handy 00 in A....
	STA	CMDD		; clear device as well.
	JMP	Cwt		; go get chr popping HL
	PAGE
; Cfird- we have to read a new sector. It's address is in
; CMDA. We put it into CBUF, with the pointers updated.

Cfird	DCX	H
	SHLD	CMDN		; one less sector.
	LXI	H,CBUF
	SHLD	CMDP		; updated pointer
	PUSH	D		; save
	XCHG			; put CBUF into DE for the read.
	LHLD	CMDA		; disk address
	INX	H
	SHLD	CMDA		; new one to read
	DCX	H		; point to right one.
	PUSH	B		; save all we can....
	MVI	B,81H		; set perm cmdf
	CALL	Cucfd		; go get access to dev
	MVI	B,1		; (it also sets CMDD in C)
	MOV	A,B		; read 1 sector
	CNC	Dio		; do read i we got access!
	POP	B
	XCHG
	POP	D
	JNC	Cwt		; go process stuff.

; We got trouble. Error on that read.

	XCHG			; code back to DE
	JMP	VErr		; go deliver the bad news.
	PAGE
;    The call to both OVRTO and GOVER is of the form
;	CALL	Ovrto	(or Gover)
;	DB	'OVLY'		; overlay desired
;	.....returns to here when thru.

Ovsv				; Ovsv is called to save
	SHLD	OVHL		; the current environment
	XCHG			; in these locations
	SHLD	OVDE
	PUSH	B
	PUSH	PSW
	POP	H
	SHLD	OVPSW
	POP	H
	SHLD	OVBC
	RET			; then return.

Ovrto	CALL	Ovsv		; save HL,DE,A,PSW
	POP	D		; return address
	LXI	H,4
	DAD	D		; new return point after name
	PUSH	H		; save that
	LHLD	OVRLY
	PUSH	H		; Remember the current overlay
	LHLD	OVRLY+2		; for returning to it.
	PUSH	H
	LXI	H,VRtn		; overlay restore point
	PUSH	H

; After "remembering", set up entry and move target name to OVNM

Ovt0	LXI	H,OVENT		; entry address
	PUSH	H		; save it for RET later.
	LXI	H,OVNM+1 ; note DE still points to text
	MVI	C,4
Ovt1	LDAX	D
	MOV	M,A		; shuffle the name over
	INX	D
	INX	H
	DCR	C
	JNZ	Ovt1

; See if OVNM matches the current  overlay. If it does, RET to
; the thing on the top of the stack. Note that this is the
; entry from RTN processing.

Ovt2	LXI	H,OVRLY
	LXI	D,OVNM+1
	MVI	C,4
Ovt3	LDAX	D
	CMP	M		; see if the right one
	JNZ	Ovt4		; jmp/got to go fetch it.
	INX	D
	INX	H
	DCR	C
	JNZ	Ovt3		; loop checking name

; We win. The overlay we want is loaded already.

Ovtg	; DI removed here	; for entry from Ovt4
	LXI	H,EFLG1
	MOV	A,M
	ANI	NOT EIC		; clear EIC to enable ^Y
	MOV	M,A
	LHLD	OVDE
	XCHG
	LHLD	OVPSW
	PUSH	H
	LHLD	OVBC
	PUSH	H
	LHLD	OVHL
	POP	B
	POP	PSW
	RET			; bye.....

; Well, not always easy. We have to read the overlay.

Ovt4	LXI	H,EFLG1
	MOV	A,M
	ORI	EIC
	MOV	M,A		; disable ^Y for a while!
	LXI	H,'VO'
	SHLD	OVNM+5		; stuff in extension
	LXI	H,OVNM
	MVI	M,4		; name length for lookup
	LDA	SYSRES		; exact match on sysres
	CALL	VRunr		; Go findee me....
	JC	Err		; jmp/oops, crap out.
	JMP	Ovtg		; else leap into the thing.
	PAGE
; Runr is the entry for loading and running things.
; You pass it in HL a pointer to the lookup block,
; and in A the drive number , plus 80H if you
; don't care about the extension matching. It will 
; return with carry clear and the SA in HL, or with
; carry set and error condition in DE.

Runr	PUSH	PSW		; save drive number for later
	CALL	VLook		; go find it
	POP	B		; restore drive number
	RC			; split/not to be found.

; Now DE points to the start of the FDE.
;
; This is where GfLoad comes to avoid hanging on its own lock
; of the semaphore to load Gfid.
;
GfRunr	PUSH	B		; stash drive number
	LDAX	D		; name length
	ANI	31		; scrub down
	ADI	3
	MVI	H,0
	MOV	L,A
	DAD	D		; point HL to FDA in the FDE
	LXI	D,MUNG1
	MVI	C,8
Runr1	MOV	A,M
	STAX	D		; copy stuff from FDE
	INX	H
	INX	D
	DCR	C
	JNZ	Runr1

; See if runnable-MUNG3 (LA from FDE) is non-zero

	LHLD	MUNG3
	MOV	A,H
	ORA	L
	JNZ	Runr2		; jmp/ok

; RUNR error 1- no load address

Rune1	LXI	D,201H		; error code/subcode
	POP	PSW		; drive number
	STC			; no f good
	RET

; Well, load the thing in already.

Runr2	POP	PSW		; Drive number
	ANI	DEVMASK		; stripped down.
	XCHG			; LA to DE
	LHLD	MUNG4		; remember the start addr?
	PUSH	H
	MOV	C,A		; drive number
	LHLD	MUNG1		; FDA from FDE
	MVI	B,1		; read
	LDA	MUNG2		; number sectors
	CALL	Dio
	POP	H		; restore start address
	RET			; and split

; Gover is like Ovrto, it just doesn't remember.

Gover	CALL	Ovsv		; save regs
	POP	D		; rtn address for caller
	LXI	H,4
	DAD	D
	PUSH	H		; new return address
	JMP	Ovt0		; blow into main processing

; Rtn is entered coming back from an Ovrto. We set up
; OVNM and registers, then blow into Ovt2 for main processing.

Rtn	CALL	Ovsv		; go save regs.

; Unwind name from stack into OVNM

	POP	H
	SHLD	OVNM+3
	POP	H
	SHLD	OVNM+1		; name now in place.
	JMP	Ovt2		; go join main process.
	PAGE
; Look is the file lookup creature. It is called with
; the registers set up as following:
;	HL -> lookup block. Name length followed by
;		name, and extension. We try to find
;		this name in the directory.
;	A -> Disk # + 80H if extension does 
;		NOT have to match.
; We search the desired device's directory
; for the file. If we find it, we will return DE 
; pointing at the head of the FDE, and the carry flag
; will be clear. If we don't find it,
; we exit with carry set, and error code in DE.

; All calls to Look must first aquire the file system
; semaphore, so that only one user at a time is diddling
; with directories. Note the checks in Kbev that prevent
; a user with the semaphore from hitting control-Y.

Look
	PUSH	PSW
	enter	GFLOCK
	POP	PSW
	STA	DONT		; don't bug me! (disable done)
	CALL	gLook		; go look it up!
	PUSH	PSW
	leave	GFLOCK		; leave section
	POP	PSW
	RET			; scram.

gLook	PUSH	H
	PUSH	PSW
	ANI	DEVMASK
	MOV	C,A		; save device number
	LDA	NFDIR		; which one do we have?
	CMP	C		; the right one?
	JZ	Looka		; *Lrd1 jmp/yup, we win.

; We don't have the right directory. Set up to go get
; the right one from the disk.

Lrdir	LXI	H,0
	XRA	A
	STA	NFDIR		; in case of read errors...
	LXI	D,SBUF1
	MVI	B,1		; read command
	MVI	A,4		; 4 sectors
	CALL	Dio
	JC	Looke		; wow...disaster time....
Lrd1	XRA	A
	STA	NFDIR		; in case of errors...
	CALL	Ckdr		; checksum the thing
	LXI	H,SBUF1
	CMP	M		; is it the same?
	JNZ	Lookd		; jmp/Frisbee time.
	STA	NFCK		; save.
	POP	PSW
	PUSH	PSW
	ANI	DEVMASK
	STA	NFDIR		; ok, directory is in.

; Ok, we have the directory, now scan it.

Looka	LXI	D,SBUF1+15 ; start scan here.

Lookb	POP	PSW
	POP	H		; restore crud
	PUSH	H
	PUSH	PSW		; and restack
	LDAX	D		; length of this FDE
	ORA	A		; well??
	JZ	Lookn		; jmp/end hit, scram
	JP	Lookc		; jmp/check this one

; We're pointing at a deleted file

	ANI	31		; strip to len
	MOV	B,A		; move over
	JMP	Look2		; and skip it.

; Strip flags+len to len and compare with wanted giz

Lookc	ANI	31
	MOV	B,A		; save over here
	MOV	A,M
	ANI	31
	CMP	B		; same length?
	JZ	Look3		; jmp/yup

; Lengths don't agree, or deleted file. Skip to next
; FDE in the list.

Look2	MOV	A,B		; length we hid away
	ADI	11		; + overhead
	MVI	H,0
	MOV	L,A
	DAD	D
	XCHG			; point to next one
	JMP	Lookb		; and continue scan

; Lengths agreed, check names

Look3	MOV	C,A		; num to check
	POP	PSW
	PUSH	PSW		; get EX check flag back
	PUSH	D		; save rescan ptr
	ANI	80H
	JNZ	Look4		; jmp/we're ok.
	INR	C
	INR	C		; check EX as well.

; Check loop.

Look4	INX	H
	INX	D
	LDAX	D
	CMP	M
	JNZ	Lookq		; jmp/not the one.
	DCR	C
	JNZ	Look4

; We found it. restore stuff and split.

	POP	D		; -> FDE
	POP	PSW		; junk
	POP	H		; junk
	ORA	A		; clear carry
	RET			; and split.

; Not the one. Get pointer to FDE start, and go skip it.

Lookq	POP	D
	JMP	Look2		; not the one.

; Looke says we didn't find it.

Lookn	MVI	E,00
	DB	21H		; error 0300 is not found
Lookd	MVI	E,0FFH		; error 03FF is bad directory
Looke	MVI	D,3		; error 03XX is I/O error XX
	POP	PSW
	POP	H		; restore stuff
	STC			; set carry
	RET			; and split.
	PAGE
; Err is the error reporter. Enter with error code in DE.
; We first Killi, and  disable. If EERR in EFLG1 is set, we
; are in trouble- we got an error reporting an error, so we go
; to Gork and die. Otherwise, we stuff the code into ERR, set
; EERR in EFLG1 for the Exec, and go to Warm to kick the Exec.

Err	CALL	VKilli		; kill input and command files
	LXI	H,EFLG1
	MOV	A,M
	ANI	EERR		; are we in trouble?
	JNZ	Gork		; wow, we are indeed.
	MOV	A,M
	ORI	EERR
	MOV	M,A		; set error
	XCHG
	SHLD	ERROR		; save the stuff
	JMP	VWarm		; and split.

; We are in deep cabbage. Scream and then die.

Gork	XCHG
	SHLD	LERR		; save as last one
	LXI	H,Bonk
	CALL	Msg		; bad news
	PUSH	H
	LHLD	ERROR
	XCHG
	CALL	VDeout		; original code/subcode
	POP	H
	INX	H
	CALL	Msg
	LXI	H,VWarm
	SHLD	PVEC
	XRA	A
	STA	DONT
	MVI	A,EERR
	STA	EFLG1		; allow ^Y to warmstart us.
Gork1	giveup
	JMP	Gork1		; chase our tail...

Bonk	db	CR,'(Error ',0,')',0
	PAGE
; Vti is the famous "Teletype Simulator" which
; drives a PolyMorphics VTI and scrolls text when
; the screen fills.  It recognizes all important control
; characters and used the SCRHM, SCEND, and POS locations
; in system RAM.

; Notes for the multiuser system - We lock during scroll.
; This insures that we won't leave partial lines on the screen
; while we aren't running.

Vti	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H		; stash environment
	LHLD	POS		; set up for most routines
	CPI	CTLX
	JZ	Cline		; ^X deletes line
	LXI	D,Scrl		; Most routines exit thru here
	PUSH	D
	MVI	M,07FH		; Blank the cursor.
	CPI	DEL
	JZ	Delr		; jmp/delete
	CPI	20H		; If above 20H, print it
	JNC	Norm		; else it's not a normal char,
				; so test it for valid CTL code
	SUI	CR
	JZ	Crr		; jmp/CR - 0DH
	INR	A
	JZ	Ffr		; jmp/FF - 0CH
	INR	A
	JZ	Vtr		; jmp/VT - 0BH
	INR	A
	INR 	A
	RNZ			; If not a tab, thru Scrl

Tab	MOV	A,L		; back up cursor to even/8
	ANI	0F8H
	MOV	L,A
	LXI	B,8		; Mov up 8 positions
	DAD	B
	RET

Norm	ORI	80H		; We have a printing char, map
				; it into char area of VTI
	MOV	M,A		; Put it in refresh mem.
	INX	H		; Move up a position.
	RET			; Go to Scrl.

; Scrl scrolls text up the scrn if necessary, then falls into
; curp, which restores the cursor and returns thru Ioret.

Scrl	LDA	SCEND
	CMP	H
	JNZ	Curp
	LHLD	SCEND
	MOV	A,H
	SUB	L
	MOV	D,H
	MVI	L,40H
	MVI	E,0
	MOV	C,L
	MOV	B,A
	CALL	VLock		; don't bug me from this point
	CALL	VMoven
	DCX	H

; Cline clears the current line

Cline	CALL	VLock		; don't bug me.
	MVI	A,3FH
	MOV	D,A
	ORA	L
	MOV	L,A
Wipe	MVI	M,7FH
	DCX	H
	DCR	D
	JNZ	Wipe

Curp	MVI	M,0FFH
	SHLD	POS
	CALL	VUnlock		; ok, we can be bugged again
	POP	H
	POP	D
	POP	B
	POP	PSW
	RET

Delr	DCX	H		; Rubout routine
	RET

Crr	LXI	B,64		; Carriage return rtn.
	MOV	A,L
	ANI	0C0H
	MOV	L,A
	DAD	B
	RET

Ffr	CALL	VLock
	CALL	Vtr		; Form feed routine
Ff1	MVI	M,7FH
	INX	H
	CMP	H
	JNZ	Ff1
	CALL	VLock		; prevents a Giveup!
	CALL	VUnlock

Vtr	LHLD	SCEND		; Vertical tab rtn.
	MOV	A,L
	MVI	L,0
	RET
	PAGE
;	Super high speed block move of BC bytes from
;  HL-> to DE->.  Uses unrolled loop technology.  Leaves
;  HL->after last byte moved from, DE->after last byte moved
;  to. Calculates checksum and returns it in B.

Moven	MOV	A,C
	CMA
	MOV	C,A
	MOV	A,B
	CMA
	MOV	B,A
	INX	B		; BC = - BC (was neg to start)

Move	MOV	A,C
	ANI	3		; Save BC MOD 4
	PUSH	PSW		; BC:=BC/4
	ORA	A		; NO CARRY.
	MOV	A,B
	RAR
	MOV	B,A
	MOV	A,C
	RAR
	MOV	C,A
	ORA	A
	MOV	A,B
	RAR
	MOV	B,A
	PUSH	PSW		; Save high byte of 4s.
	MOV	A,C
	RAR
	MOV	C,A
	MVI	B,0		; Initialize checksum.
	ORA	A
	JZ	Move1		; If C=zero, skip it.
	CALL	Move2
Move1	POP	PSW		; Get high byte # of 4s.
	ORA	A
	JZ	Move0
	DCR	A
	PUSH	PSW
	CALL	Move2		; C was already zero: 256*4.
	JMP	Move1
Move0	POP	PSW		; Get back odd number bytes.
	MOV	C,A

; Move an exact number of bytes in C.

Move3	MOV	A,C
	ORA	A
	RZ		; C=0 means all done.
Move4	MOV	A,M
	STAX	D
	ADD	B
	MOV	B,A	; Update checksum in B.
	INX	H
	INX	D
	DCR	C
	JNZ	Move4
	RET

; Move C*4 bytes. C=0 means move 256*4 bytes.  Update the
;  checksum in B.

Move2	MOV	A,M
	STAX	D
	ADD	B		; Update checksum in B.
	MOV	B,A
	INX	H
	INX	D
	MOV	A,M
	STAX	D
	ADD	B
	MOV	B,A
	INX	H
	INX	D
	MOV	A,M
	STAX	D
	ADD	B
	MOV	B,A
	INX	H
	INX	D
	MOV	A,M
	STAX	D
	ADD	B
	MOV	B,A
	INX	H
	INX	D	; All this trouble to be able to just
	DCR	C	; DCR C once per every 4 bytes.
	JNZ	Move2
	RET		; Ret/ C=0.

;********
