; PCmon is invoked to watch the other guy's registers.
; It's a very useful debugging aid......

grunt	MACRO
#L	XCHG
	LHLD	#1
	XCHG
	CALL	Deout
	INX	H
	CALL	Msg
	ENDM

PCmon	LDA	PMASK
	ORA	A
	LXI	D,204H		; What? error message
	JZ	OHNO		; scram if single user!
	MVI	A,0CH
	CALL	WH1		; clear the screen!
	XRA	A
	STA	SBRK		; clear control-Y hit

PCLoop	DI
	LDA	SBRK
	ORA	A
	JNZ	CONTY		; bug out on ^Y
	STA	TIMER		; rezero timer cell

	LXI	D,USP		; get his stack pointer
	LXI	H,HISUSP
	LXI	B,2		; 2 bytes
	CALL	Mfos

	LHLD	HISUSP
	XCHG
	LXI	H,HISHL
	LXI	B,12
	CALL	Mfos

	EI			; let others intrude
	LXI	H,Text
	CALL	Msg

	grunt	HISUSP
	grunt	HISHL
	grunt	HISDE
	grunt	HISBC
	grunt	HISAF
	grunt	HISPC

Guk	CALL	Giveup
	LDA	TIMER
	CPI	4
	JC	Guk		; no more than 15 times a sec
	JMP	PCLoop

Text	db	0BH,' SP = ',0,' HL = ',0
	db	' DE = ',0,' BC = ',0
	db	' AF = ',0,' PC = ',0,' ',0

HISUSP	DW	0
HISHL	DW	0
HISDE	DW	0
HISBC	DW	0
HISAF	DW	0
HISPC	DW	0
	DS	10
