;********************************************************
;*							*
;*		      Set New Bits			*
;*							*
;*	Version 0.1			Brian F.Smith	*
;*	02/08/81					*
;*							*
;*							*
;*							*
;********************************************************
;
	REFS	SYSTEM
	REF

CR	EQU	13
TAB	EQU	9
COMMA	EQU	44
SPACE	EQU	32


	ORG	USER
	IDNT	$,$

	JMP	START
	JMP	START
;
;	Find first non space, tab or comma.  Return HL
;  pointing at it.
;
BREAK	MOV	A,M
BRK1	INX	H
	CPI	COMMA
	JZ	BRK1
	CPI	SPACE
	JZ	BRK1
	CPI	TAB
	JZ	BRK1
	DCX	H
	RET
;
;	Find start of next field.  If comma, space or tab,
;  return zero.  If CR return non-zero.
;
NXTFIELD
	MOV	A,M
	INX	H
	CPI	COMMA
	RZ
	CPI	SPACE
	RZ
	CPI	TAB
	RZ
	CPI	CR
	JNZ	NXTFIELD
	ORA	A
	RET


START	LHLD	CMPTR		; Get pointer.
	CALL	BREAK		; skip tab, comma and spaces.
	SHLD	CMPTR		; store new pointer.
	CPI	CR		; Is this the end?
	RZ			; yup, quit.
	LXI	D,FILE		; build it here.
	MVI	A,040H		; look

	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Gover
	db	'Gfid'
	ENDIF

	JC	Err		; Sorry.
	LXI	H,FILE		; Here ah is!
	MVI	A,081H		; Replace, set new bit.

	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Gover
	db	'Gfid'
	ENDIF

	JC	Err
	LHLD	CMPTR		; Get start of last field.
	CALL	NXTFIELD	; go to start of next.
	SHLD	CMPTR		; Save new pointer.
	JZ	START		; Zero = no CR found.
	RET			; Next field is CR, quit.
	END
