REM
REM	Program to plote throughput vs. loading
REM	of  carrier Sense Multiple Access (CSMA) network.
REM
REM	S = throughput
REM	G = Arrival rate of new and rescheduled packets
REM	A = delay/packet time ratio
REM
REM	S=(Ge**-AG)/G(1+2A-Ae**-AG)+2e**-AG-e**-2AG
REM
100	PRINT"CSMA Throughput Program"
110	INPUT"Enter packet size (bits):  ",S
120	INPUT"Enter bandwidth (bits/sec.):  ",B
130	INPUT"Enter delay time  (sec.):  ",T
140	A=T/(S/B)
190	PRINT CHR$(12),"a=",A
200	FOR I=0 TO 127
210	G=10^(I/25-2)\X=EXP(-A*G)
220	S=(G*X)/(G*(1+2*A-A*X)+2*X-EXP(-2*A*G))
230	PLOT I,S*47,1
240	NEXT
300	INPUT"",A$
310	GOTO 110
RUN
