REM **********************************************************
REM		I N I T I A L   P R O G R A M
REM **********************************************************
REM	Copyright 1978, 1979, 1980, Interactive Products Corp.
REM	PolyMorphic Systems, Santa Barabara, California
REM **********************************************************
REM	While we believe this program to be accurate,
REM	PolyMorphic Systems assumes no liability, either
REM	explicit or implied for the use of this program.
REM	It is the responsibility of the user to determine
REM	the accuracy and correctness of this program.
REM **********************************************************
REM
1 IF PEEK(8)>245 THEN 5
2 PRINT "BASIC must be version C02!"\STOP
5 ON ESCAPE GOTO 18970
6 POKE 4+PEEK(2),195
7 ON ERROR GOSUB 900\PAUSE 120\PRINT CHR$(24),\GOTO 15
8 DIM Z8$(1:63),Z3$(1:63),S1$(1:45),S2$(1:8)
10 FILE:2,LIST
11 GOTO 20
15 IF FNQ("The printer is busy!  Shall I check again?",1) THEN 10
18 GOTO 18970
REM
REM **********************************************************
REM		READ PROBLEM SIZE & DIMENSION VARIABLES
REM		L1=MAXIMUM LINES    K=MAXIMUM COLUMNS
REM **********************************************************
REM
20 ON ERROR GOSUB 900\PAUSE 180\GOTO 18970
22 FILE:6,OPEN,"PLAN<PROBLEM-SIZE.DT",INPUT
25 INPUT:6,L1
26 INPUT:6,K
30 DIM B$(1:10),D$(1:30),H$(3:40),C$(K:10),Z7$(1:1),F$(4:31)
35 DIM V(L1,K),R$(L1+1:31),Z9$(1:1),I$(1:63),W1$(1:20)
37 DIM N$(1:31)
REM Rules-text file name
40 DIM A$(15:80)
REM pre-written rules buffers
42 DIM L$(1:3)
REM counter for number of lines
43 DIM N1$(1:31)
REM Name of Command file
44 DIM N2$(1:31)
REM Rules file name
45 DIM N3$(1:31)
REM Rules SAVEF file name
REM
REM **********************************************************
REM		DISPLAY HEADING
REM **********************************************************
REM
50 PRINT CHR$(12)\PRINT
52 PRINT TAB(30),"PLAN"
53 PRINT TAB(15),"PolyMorphic's Language for ANalysis"
54 PRINT TAB(27),"Version 3.1"\PRINT
55 PRINT TAB(25),"Copyright 1980"
56 PRINT TAB(23),"PolyMorphic Systems"
57 PRINT TAB(23),"All rights reserved"
REM
REM **********************************************************
REM		PROMPT FOR DATE
REM **********************************************************
REM
60 ON ERROR GOSUB 900\PAUSE 180\GOTO 75
65 FILE:6,OPEN,"PLAN<DAT.DT",INOUT
70 PRINT\PRINT\INPUT:6,D$
75 PRINT D$
80 IF FNQ("Is date OK ? ",1) THEN 95
90 INPUT  "Enter today's date : ",D$
92 GOTO 75
95 PRINT:6,D$,TAB(32)\FILE:6,CLOSE
REM
REM **********************************************************
REM		DISPLAY MENU
REM **********************************************************
REM
100 ON ESCAPE GOTO 100
103 ON ERROR GOSUB 900\ PRINT " in line",LINE,\PAUSE 120\GOTO100
105 PRINTCHR$(12),
106 Z=FNP(24)\PRINT "PLAN"
107 MATV=0
110 PRINT TAB(19),D$
120 MATR$=""
130 PRINT %#
150 PRINT TAB(10),"1-Create a Report Specifications file"
155 MATC$=""
160 PRINT TAB(10),"2-Modify a Report Specifications file"
165 MATH$=""
170 PRINT TAB(10),"3-Create a new Values file"
175 MATF$=""
180 PRINT TAB(10),"4-Modify a Values file"
181 PRINT TAB(10),"5-Print Report"
182 PRINT TAB(10),"6-Compute Values"
183 PRINT TAB(10),"7-Display Values"
184 PRINT TAB(10),"8-Create Calculation Rules file"
185 PRINT TAB(10),"9-Printer functions"
190 PRINT TAB(9),"10-Done"
201 INPUT1 "          ..enter number for function desired : ",I$
202 IF FNI1(I$) THEN T=VAL(I$)\GOTO 205
203 PRINT CHR$(24),"Enter a number, please!",\PAUSE 120\PRINT CHR$(24),\GOTO 201
205 IF FNR(1,10,T) THEN PAUSE 120\PRINT CHR$(24),\GOTO 201
210 PRINT
220 ON T GOTO 11000,12000,13000,14000,15000,16000,17000,18000,18500,18970
REM
REM **********************************************************
REM **********************************************************
REM **********************************************************
REM
REM		  SUBROUTINES
REM
REM **********************************************************
REM **********************************************************
REM **********************************************************
REM
REM **********************************************************
REM		WRITE REPORT SPECS
REM **********************************************************
REM
300 PRINT"..writing Report Specifications file.."
302 ON ERROR GOTO 380
305 F$(1)=F$(1)+".PS"\FILE:6,OPEN,F$(1),OUT
310 PRINT:6,L2
315 PRINT:6,C1
320 MATPRINT:6,H$
330 MATPRINT:6,R$
340 MATPRINT:6,C$
370 FILE:6,CLOSE\RETURN
380 IF ERR<>1536 THEN GOSUB 900\GOTO 390
385 PRINT CHR$(24),"That report name in use!",
390 PAUSE 120\PRINT CHR$(24),\GOSUB 700\GOTO300
REM
REM **********************************************************
REM		READ REPORT SPECS
REM **********************************************************
REM
400 ON ERROR GOTO 480
405 F$(1)=F$(1)+".PS"\FILE:6,OPEN,F$(1),INPUT
410 PRINT"..reading"
420 INPUT:6,L2
430 INPUT:6,C1
440 MATINPUT:6,H$
450 MATINPUT:6,R$
460 MATINPUT:6,C$
470 RETURN
480 IF ERR<>768 THEN GOSUB 900\GOTO 483
482 PRINT CHR$(24),"...no Report Specifications file by that name.",
483 PAUSE 120\PRINT CHR$(24),\GOSUB 700\GOTO 400
REM
REM **********************************************************
REM		WRITE VALUES FILES
REM **********************************************************
REM
500 PRINT CHR$(24),
505 INPUT1 "Enter name of NEW values file : ",F$(2)
510 ON ERROR GOTO 550
520 F$(2)=F$(2)+".PV"\FILE:6,OPEN,F$(2),OUT
530 PRINT\PRINT"..writing Values file.."
540 MATPRINT:6,V\FILE:6,CLOSE\ RETURN
550 IF ERR<>1536 THEN GOSUB 900\GOTO 570
560 PRINT CHR$(24),"That values file already exists.",
570 PAUSE 120\GOTO 500
REM
REM **********************************************************
REM		PROMPT FOR REPORT SPECS FILE
REM **********************************************************
REM
700 PRINT CHR$(24),
720 INPUT1"Name of Report Specifications file : ",F$(1)\RETURN
REM
REM
REM **********************************************************
REM		PROMPT FOR VALUES FILE
REM **********************************************************
REM
800 PRINT CHR$(24),
805 INPUT1"Name of Values file (RETURN for none) : ",F$(2)
810 IF F$(2)="" THEN RETURN
820 ON ERROR GOTO 870
830 F$(2)=F$(2)+".PV"\FILE:6,OPEN,F$(2),INPUT
840 PRINT"..reading"
850 MATINPUT:6,V
860 RETURN
870 IF ERR<>768 THEN GOSUB 900\GOTO 890
880 PRINT CHR$(24),"...no Values file by that name.",
890 PAUSE 120\PRINT CHR$(24),\GOTO 800
REM
REM **********************************************************
REM		Print error message and line number.
REM **********************************************************
REM
900 PRINT CHR$(24),
930 Z=CALL("Berr",5,0,ERR,0)
940 RETURN
REM
REM **********************************************************
REM		    Enter report heading.
REM **********************************************************
REM
1000 FOR I=1 TO 3
1010 PRINT\PRINT "Enter line",I," of report heading"
1020 INPUT ": ",H$(I)\NEXT
1030 PRINT CHR$(12),
1040 PRINT "Report name ",F$(1)\PRINT
1050 FOR I=1 TO 3\PRINT H$(I)\NEXT\PRINT
1070 IF FNQ("..is this CORRECT ? ",0) THEN RETURN
1090 GOTO 1000
REM
REM **********************************************************
REM		Enter column headings.
REM **********************************************************
REM
1100 PRINT CHR$(12)\PRINT TAB(15),"COLUMN HEADINGS"\PRINT
1105 C1=FNI("Enter number of columns in report       : ")
1110 IF C1>K THEN PRINT CHR$(24),K," is the current maximum number" \PAUSE 120\GOTO 1105
1115 FOR I=1 TO C1
1120 PRINT\PRINT"Enter heading for column ",I,
1125 INPUT " : ",C$(I)
1130 IF LEN(C$(I))<10 THEN 1145
1135 PRINT "Column heading more than 9 characters-REENTER"
1140 GOTO 1120
1145 NEXT
1150 PRINTCHR$(12)\PRINT "COLUMN HEADINGS FOR ",F$(1)\PRINT
1155 FOR I=1 TO C1\PRINT "Column ",I," : ",C$(I)\NEXT\PRINT
1170 IF FNQ("..is this correct ? ",0) THEN RETURN
1175 GOTO 1100
REM
REM **********************************************************
REM		Enter line descriptions.
REM **********************************************************
REM
1200 PRINT CHR$(12)\PRINT"LINE DESCRIPTIONS:"
1205 PRINT "Enter line number (1 to ",L1," )",
1210 PRINT" & description (type END to stop)" 
1215 PRINT\PRINT "Number",TAB(16),"Description"
1220 PRINT TAB(16),"______________________________"
1223 ON ERROR GOSUB 900\PAUSE 120\GOTO 1225
1225 N=FNI( ":")
1230 IF FNR(1,L1,N) THEN 1225
1235 Z=FNP(15)
1240 INPUT":",R$(N)\IF LEN(R$(N))<31 THEN 1245
1242 PRINT "Line description longer than 30 characters-REENTER"
1243 GOTO 1225
1245 IF R$(N)="END" THEN RETURN
1250 IF N < 5 THEN 1215
1255 PRINT CHR$(12)\PRINT"LINE DESCRIPTIONS:"
1260 PRINT
1265 PRINT "Enter line number (1 to ",L1," )",
1270 PRINT" & description (type END to stop)" 
1275 FOR I=N-4 TO N\PRINT I,TAB(16),R$(I)\NEXT
1280 GOTO 1215
REM
REM **********************************************************
REM		Save report specifications option.
REM **********************************************************
REM
1300 PRINT CHR$(12)
1310 Z8$="Do you want to save these Report Specifications ? "
1330 IF FNQ(Z8$,0) THEN GOSUB 300
1340 RETURN
REM
REM **********************************************************
REM	Ask question Z8$.  Return 1 for yes, 0 for no or CR.
REM  Ask again on anything else.
REM **********************************************************
REM
1400 DEF FNQ(Z3$,A)
1410 IF A=0 THEN PRINT CHR$(24),
1415 PRINT Z3$,
1420 INPUT1 " ", Z9$
1425 IF Z9$="" THEN PRINT\RETURN 0
1430 P9=ASC(Z9$) OR 32\IF P9=121 THEN PRINT\RETURN 1
1440 IF P9=110 THEN PRINT\RETURN 0
1450 PRINT CHR$(24),\GOTO 1410
1460 FNEND
REM
REM **********************************************************
REM	Plot to character position passed on current line.
REM **********************************************************
REM
1470 DEF FNP(A)
1475 P4=PEEK(0)\POKE P4,127
1480 PLOT 2*A,3*(15-(INT((P4-PEEK(6)*256)/64))),0
1485 RETURN A
1490 FNEND
REM
REM **********************************************************
REM		Numeric input function.
REM **********************************************************
REM
REM	Returns value of number input and sets P6 to length
REM  of input string.
REM
1500 DEF FNI(Z3$)
1510 PRINT CHR$(24),Z3$,
1520 INPUT1 " ",I$
1535 IF FNI1(I$) THEN RETURN VAL(I$)
1590 PRINT CHR$(24),"Enter a number please!",\PAUSE 140\GOTO 1510
1595 FNEND
REM
REM **********************************************************
REM		Range check function.
REM **********************************************************
REM
1596 DEF FNR(A,B,C)
1597 IF C=>A AND C<=B THEN RETURN 0
1598 PRINT CHR$(24),A," through",B," please.",\PAUSE 120\RETURN 1
1599 FNEND
REM
REM **********************************************************
REM		Print report option.
REM **********************************************************
REM
1600 Z8$="Do you want to print a sample report ? "
1610 IF FNQ(Z8$,0) THEN GOSUB 19000
1630 RETURN
REM
REM **********************************************************
REM		Check string to see if valid number.
REM **********************************************************
REM
1640 DEF FNI1(I$)
1642 P7=0\IF I$=""THEN RETURN 0
1644 P6=LEN(I$)
1646 FOR P9=1 TO P6
1648 P8=ASC(I$,P9)
1650 IF (P8=45ANDP9=1) OR (P8=46ANDP7=0) OR (P8>47ANDP8<58) THEN 1654
1652 EXIT 1660
1654 IF P8=46 THEN P7=1
1656 NEXT
1658 RETURN 1
1660 RETURN 0
1662 FNEND
REM
REM **********************************************************
REM			Display values.
REM **********************************************************
REM
1700 PRINT CHR$(12)\PRINT TAB(15),"Display Values"\PRINT
1705 ON ERROR GOTO 1710
1710 N1=FNI("Enter first line number you want to display (0 to Stop) : ")
1715 IF N1=0 THEN 1795
1720 IF (N1<1) OR (N1>L1) THEN PRINTCHR$(24), "Line number out of range",\PAUSE 120\GOTO 1710
1722 PRINT
1725 N2=FNI("Enter last line number you want to display              : ")
1730 IF (N2<1) OR (N2>L1) THEN PRINT CHR$(24),"Line number out of range",\PAUSE 120\GOTO 1725
1732 PRINT
1735 IF N2-N1 < 0 THEN PRINT "You must enter lower line number first"\GOTO 1705
1745 FOR I=N1 TO N2
1750 IF R$(I)=" " THEN 1785
1755 IF LEFT$(R$(I),1)="b" THEN 1785
1760 IF LEFT$(R$(I),1)="f" THEN 1785
1765 IF LEFT$(R$(I),1)="_" THEN 1785
1770 IF RIGHT$(R$(I),1)="^" THEN 1785
1775 PRINT %3I,I,"   ",R$(I)
1780 FOR J=1 TO C1\PRINT %#8I,INT(V(I,J)),\NEXT\PRINT %#
1785 NEXT
1790 PRINT\GOTO 1705
1795 PRINT\RETURN
REM
REM **********************************************************
REM		DISPLAY AND/OR SAVE VALUES
REM **********************************************************
REM
10000 IF FNQ("Do you want to display the computed values? ",0) THEN GOSUB 1700
10052 IF FNQ("Do you want to print the computed values? ",0) THEN GOSUB 19000
10070 IF FNQ("Do you want to save the computed values? ",0) THEN GOSUB 500
10090 GOTO 100
REM
REM **********************************************************
REM 		Report Calculation rules error.
REM **********************************************************
REM
10900 PRINT\GOSUB 900
10905 PRINT
10907 PRINTTAB(10),"There's an error in calculation rules"
10910 WAIT\GOTO 100
REM **********************************************************
REM **********************************************************
REM **********************************************************
REM 			END OF SUBROUTINES
REM **********************************************************
REM **********************************************************
REM **********************************************************
REM
REM **********************************************************
REM
REM	Menu item 1. Create report specification file.
REM
REM		      ENTER REPORT SPECS
REM **********************************************************
REM
11000 GOSUB 700
11005 ON ERROR GOSUB 900\ GOTO 100
11010 PRINT CHR$(12)\PRINT TAB(15),"Enter Report Specifications"\PRINT
11020 GOSUB 1000
11022 GOSUB 1100
11024 GOSUB 1200
11025 GOSUB 1600
11028 GOSUB 1300
11030 GOTO 100
REM
REM **********************************************************
REM
REM	Menu item 2.  Modify report specification file.
REM
REM		MODIFY REPORT SPECS
REM **********************************************************
REM
12000 GOSUB 700
12010 GOSUB 400
12020 PRINT CHR$(12),\PRINT TAB(15),"Modify Report Specifications"
12030 PRINT
12040 PRINT "What do you want to change..."
12045 PRINT "   1-Report Headings"
12050 PRINT "   2-Column Headings"
12060 PRINT "   3-Line Descriptions"
12070 PRINT "   4-Done"
12075 ON ERROR: GOSUB 900\PAUSE 120\GOTO 12020
12080 T1=FNI( "..enter number for your selection..")
12085 IF FNR(1,4,T1) THEN 12080\PRINT
12090 ON T1 GOSUB 1000,1100,1200,1600
12100 IF T1<>4 THEN 12020
12300 Z8$="Do you want to save these specifications ? "
12310 IF FNQ(Z8$,0) THEN 12600
12330 GOTO 100
12600 INPUT"Enter name of NEW Report Specifications file : ",F$(1)
12620 GOSUB 300\GOTO 100
REM
REM **********************************************************
REM
REM	Menu item 3. Create new values.
REM
REM		ENTER NEW VALUES ROUTINE
REM **********************************************************
REM
13000 GOSUB 700
13010 GOSUB 400
13020 PRINT CHR$(12)\PRINT "Enter New Values"\PRINT
13030 ON ERROR GOSUB 900\WAIT\GOTO 13040
13040 I=FNI("Line (type 0 to stop): ")
13042 IF I=0 THEN GOSUB 1600\GOTO13070
13044 IF (I<1) OR (I>L1)THEN PRINT CHR$(24),"No such line!",\PAUSE 120\GOTO13040
13046 Z=FNP(32)\PRINT R$(I)
13048 ON ERROR GOSUB 900\PAUSE 120\GOTO13050
13050 J=FNI("Column (0 to stop): ")
13053 IF J=0 THEN PRINT\PRINT\GOTO 13040
13055 IF (J<1) OR (J>C1) THEN PRINT CHR$(24),"No such column!",\PAUSE 120\GOTO 13050
13057 Z=FNP(24)\PRINT C$(J),V(I,J),TAB(44),
13060 INPUT1 "Value: ",I$\IF FNI1(I$) THEN V(I,J)=VAL(I$)\PRINT\GOTO 13050
13062 PRINT CHR$(24),"Enter a number please!",\PAUSE 120\GOTO13048
13070 Z8$="Do you want to save these values ? "
13080 IF FNQ(Z8$,0) THEN GOSUB 500
13100 Z8$="Do you want to perform calculations "
13110 IF FNQ(Z8$,0) THEN 16050
13130 GOTO 100
REM
REM **********************************************************
REM
REM	Menu item 5. Change values.
REM
REM		CHANGE OLD VALUES ROUTINE
REM **********************************************************
REM
14000 GOSUB 700
14010 GOSUB 400
14020 GOSUB 800
14030 IF F$(2)="" THEN 100
14040 PRINTCHR$(12)\PRINT TAB(15),"Change Values"
14060 PRINT
14070 ON ERROR GOSUB 900\PAUSE 120\GOTO 14071
14071 I=FNI("Line Number (type 0 to stop): ")
14080 IFI=0 THEN 14200
14090 IF(I<1)OR(I>L1)THENPRINT CHR$(24),"No such line!",\PAUSE 120\GOTO 14070
14095 Z=FNP(32)\PRINT R$(I)
14100 ON ERROR GOSUB 900\WAIT\GOTO 14105
14105 J=FNI("Column (0 to stop): ")
14110 IFJ=0THENPRINT\PRINT\GOTO 14070
14120 IF(J<1)OR(J>C1)THEN PRINT CHR$(24),"No such column!",\PAUSE 120\GOTO 14100
14125 Z=FNP(24)\PRINTC$(J),V(I,J),TAB(44),
14131 INPUT1 "Value: ",I$\IF FNI1(I$) THEN V(I,J)=VAL(I$)\PRINT\GOTO 14100
14133 PRINT CHR$(24),"Enter a number, please!",\PAUSE 120\GOTO 14100
14200 GOSUB 1600
14500 Z8$="Do you want to save these values ? "
14510 IFFNQ(Z8$,0)THENGOSUB500
14530 Z8$="Do you want to perform calculations "
14540 IFFNQ(Z8$,0)THEN16050
14560 GOTO100
REM
REM **********************************************************
REM
REM	Menu item 5. Print Report.
REM
REM		GET PRINT PROGRAM
REM **********************************************************
REM
REM
15000 GOSUB 700\GOSUB 400\GOSUB 800
15060 PRINT CHR$(12),\PRINT TAB(15),"Print Report"
15080 GOSUB 19000\GOTO 100
REM
REM **********************************************************
REM
REM	Menu item 6. Compute Values.
REM
REM		GET CALC RULES
REM **********************************************************
REM
16000 GOSUB 700
16010 GOSUB 400
16020 GOSUB 800
16030 IF F$(2)="" THEN 100
16040 PRINTCHR$(12),\PRINTTAB(15),"Calculate Values"
16050 INPUT1 "Enter name of calculation rules : ",F$(3)
16060 ON ERROR GOTO 16090
16070 PRINT\PRINT"..loading calculation rules.."
16080 F$(3)=F$(3)+".BS"\CHAIN F$(3)
16090 IF ERR<>768 THEN GOSUB 900\GOTO 16110
16100 PRINT CHR$(24),"No such rules found ",
16110 PAUSE 120\PRINT CHR$(24),\GOTO 16050
REM
REM **********************************************************
REM		    Menu item 7. Display values.
REM **********************************************************
REM
17000 GOSUB 700\GOSUB 400\GOSUB 800\GOSUB 1700\GOTO100
REM
REM **********************************************************
REM	Menu item 8.  Create Calculation rules.
REM
REM		LOAD CREATE ROUTINE
REM **********************************************************
REM
18000 PRINT "...loading create routine..."
18005 ON ERROR GOTO 18020
18010 CHAIN "PLAN<GEN"
18020 GOSUB 900\PAUSE 120\GOTO 100
REM
REM **********************************************************
REM
REM		Menu item 9. Printer stuff.
REM
REM		Various printer stuff.
REM **********************************************************
REM
18500 ON ESCAPE GOTO 18500
18510 PRINT CHR$(12)\PRINT\PRINT\PRINT TAB(25),"PRINTER MENU"
18520 PRINT\PRINT\PRINT TAB(10),"1. Connect new printer"
18521 PRINT TAB(10),"2. View page parameters"
18522 PRINT TAB(10),"3. Set page parameters"
18523 PRINT TAB(10),"4. Move paper to top of form"
18524 PRINT TAB(10),"5. Return to main menu"
18525 INPUT1 "          ..enter number for function desired : ",I$
18526 IF FNI1(I$) THEN T=VAL(I$)\GOTO 18530
18527 PRINT CHR$(24),"Enter a number, please!",\PAUSE 120\PRINT CHR$(24),\GOTO 18525
18530 IF FNR(1,5,T) THEN 18525
18535 PRINT
18540 ON T GOTO 18800,18700,18750,18600,100
18600 PRINT:2,CHR$(12),\GOTO 18500
18700 PRINT CHR$(12)\Z=CALL("Prnt",5,0,0,0)\PRINT\WAIT\GOTO 18500
18750 PRINT CHR$(12)\Z=CALL("Prnt",6,0,0,0)\PRINT\WAIT\GOTO 18500
18800 PRINT CHR$(12)\PRINT\PRINT TAB(10),"Which printer do you want connected?",
18810 INPUT " ",W1$\W1$=W1$+CHR$(13)
18820 Z=CALL("Prnt",2,0,0,MEM(W1$))\PRINT\WAIT
18825 ON ERROR GOSUB 900\PAUSE 120\PRINT CHR$(24),\GOTO 18850
18830 FILE:2,CLOSE\FILE:2,LIST
18840 GOTO 18500
18850 IF FNQ("The printer is busy!  Shall I check again?",1) THEN 18830
18860 GOTO 18970
REM
REM **********************************************************
REM
REM		Menu item 10. Quit.
REM
REM		ABORT--RETURN TO EXEC
REM **********************************************************
REM
18970 PRINT CHR$(12),
18972 S1$="                                            "
18975 S2$="FINAL"+CHR$(13)
18980 Z=CALL("Gfid",64,0,MEM(S1$),MEM(S2$))
18985 Z=(ASC(S1$,2)AND31)\IF (ASC(S1$,Z+7)+ASC(S1$,Z+8)) THEN 18995
18990 S2$="; "
18995 Z=CALL(0,S2$)
REM
REM **********************************************************
REM		P R T   P R O G R A M
REM **********************************************************
REM	Copyright 1978, 1979, 1980, Interactive Products Corp.
REM	PolyMorphic Systems, Santa Barabara, California
REM **********************************************************
REM	While we believe this program to be accurate,
REM	PolyMorphic Systems assumes no liability, either
REM	explicit or implied for the use of this program.
REM	It is the responsibility of the user to determine
REM	the accuracy and correctness of this program.
REM **********************************************************
REM
19000 ON ERROR GOTO 19600
19003 ON ESCAPE: GOTO 19605
19005 INPUT"Do you want the line numbers printed             : ",Z5$
19009 PRINT"Enter 'Run Description' to be printed"
19010 INPUT":",F$(4)
19011 Z7=FNI("Enter Number of Decimal Places in Values (0 or 2) : ")
19012 IF FNR(0,2,Z7) THEN 19011
19013 IF Z7=1 THEN 19011 ELSE PRINT
19014 Z6=FNQ("Do you want to print all lines on the report      : ",0)\IF Z6 THEN L8=L1\GOTO 19019
19015 Z6=FNI("Enter number of first line to be printed         : ")\PRINT
19016 L8=FNI("Enter number of last line to be printed          : ")\PRINT
REM
REM
REM
19019 ON ERROR GOTO 19600
19020 PRINT"..Printing Report.."\P=0
REM
REM	Find Wormhole 5 (PEEK (2)+20).  Then build an
REM  assembly language program in W5$ that returns the
REM  characters per line from WH5.  The program:
REM
REM	MVI	A,83H	; How many cpl?
REM	CALL	WH5	; Ask WH5.
REM	MOV	L,A	; Put answer in HL
REM	MVI	H,0	; for BASIC.
REM	RET		; Back to BASIC.
REM
REM	Using the value returned, set E1 to the number of
REM  columns that will fit on a single page.
REM
19021 W5=20+PEEK(2)\W4=MOD(W5,256)\W3=INT(W5/256)
19022 W5$=CHR$(62)+CHR$(131)+CHR$(205)+CHR$(W4)+CHR$(W3)+CHR$(111)+CHR$(38)+CHR$(0)+CHR$(201)
19023 W5=CALL(MEM(W5$))
19024 E1=INT((W5-40)/10)
REM
REM	Do as many pages as necessary to print entire report.
REM  Put E1 columns on each page until there are less than E1
REM  left.  Put remainder on last page.
REM
19025 IF C1<E1 THEN E1=C1 
19050 B=1\E=E1\GOSUB 19090
19055 GOSUB 19370\IF E=C1 THEN 19390
19057 B=E+1\E=E+E1\IF E>C1 THEN E=C1
19060 GOSUB 19090\GOTO 19055
REM
REM
REM
19090 GOSUB 19100\GOSUB 19200\RETURN
REM
REM
REM
19100 PRINT:2,TAB(5),H$(1),TAB(W5-20),"PLAN"
19115 P=P+1\PRINT:2,TAB(5),H$(2),TAB(W5-20),D$
19120 PRINT:2,TAB(5),H$(3),TAB(W5-20),"Page No. ",P
19125 PRINT:2,CHR$(0)
19130 PRINT:2,F$(4),TAB(40),
19135 FOR I2=B TO E
19137 I3=I2-B+1
19140 PRINT:2,C$(I2),\PRINT:2,TAB(40+I3*10),
19150 NEXT\PRINT:2,CHR$(0)
19160 FOR I2=1 TO 38\PRINT:2,"-",\NEXT
19165 GOSUB 19330
19170 RETURN
REM
REM
REM
19200 FOR I=Z6 TO L8
19205 IF R$(I)=" " THEN 19320
19206 IF LEN(R$(I))=0 THEN 19320
19207 IF R$(I)=CHR$(13) THEN 19320
19210 IF R$(I)="END" THEN EXIT 19321
19215 IF LEFT$(R$(I),1)="b" THEN PRINT:2,CHR$(0)\GOTO 19320
19220 IF LEFT$(R$(I),1)="_" THEN GOSUB 19330\GOTO 19320
19225 IF LEFT$(R$(I),1)="f" THEN PRINT:2,CHR$(12),\GOSUB 19100\GOTO 19320
19226 IF LEFT$(R$(I),1)=CHR$(13) THEN 19320
19228 IF RIGHT$(R$(I),1)<>"^" THEN 19230
19229 L9=LEN(R$(I))-1\PRINT:2,LEFT$(R$(I),L9)\GOTO 19320
19230 PRINT:2,R$(I),
19235 IF LEFT$(Z5$,1)="N" THEN PRINT:2,TAB(39),\GOTO 19265
19240 IF LEFT$(Z5$,1)="n" THEN PRINT:2,TAB(39),\GOTO 19265
19250 IF RIGHT$(R$(I),1)="^" THEN PRINT:2,CHR$(0)\GOTO 19360
19260 PRINT:2,TAB(33),"(",%3I,I,") ",
19265 IF Z7=2 THEN PRINT %#10F2,\GOTO 19270
19266 PRINT %#10F0,
19270 FOR I1=B TO E
19280 IF V(I,I1)<> 0 THEN PRINT:2,V(I,I1),\GOTO 19300
19290 PRINT:2,"         -",
19300 NEXT
19305 PRINT %#,
19310 PRINT:2,CHR$(0)
19320 NEXT
19321 RETURN
REM
REM
REM
19330 PRINT:2,TAB(40),
19340 FOR N1=B TO E
19350 FOR N2=1 TO 9\PRINT:2,"-",\NEXT\PRINT:2," ",
19360 NEXT\PRINT:2,CHR$(0)\RETURN
19370 FOR I=1TO3\PRINT:2,CHR$(0)\NEXT\PRINT:2,F$(1),"  ",F$(2)
19380 PRINT:2,CHR$(12),\RETURN
REM
REM
REM
19390 IF FNQ("Do you want an additional copy : ",0) THEN 19019
19500 RETURN
REM
19600 GOSUB 900\PAUSE 120\GOTO19500
19605 PRINT:2,CHR$(10),CHR$(10)\PRINT:2,TAB(W5-40),"...Printing Aborted...."
19610 PRINT:2,CHR$(12),\GOTO 100
REM **********************************************************
REM **********************************************************
REM			END OF PROGRAM
REM **********************************************************
REM **********************************************************
