10 DIGITS 6
REM
REM  allow 64 directory names
REM
100 DIM N$(64:32)
REM
REM  list of head pointers into file table
REM
110	DIM H(64)
REM
REM  list of tail pointers into file table
REM
120	DIM T(64)
REM
REM  list of address of all directories
REM
130	DIM A(64)
REM
REM  directory buffer
REM
140 DIM D$(1:1024)
REM
REM  current directory pathname
REM
150 DIM P$(1:32)
REM
REM  current volume name
REM
155 DIM V$(1:32)
160 DIM Q$(1:32), Z$(1:32), Z1$(1:32), Z2$(1:32)
170 DIM S$(1:32), T$(1:32)
180 A=INT((FREE(0)-2000)/40)
REM
REM  allow for a total of 256 file names
REM
190 DIM F$(A:32)
REM
REM  mode of each file in file name list
REM
200 DIM M(A)
1000 PRINT CHR$(12),"FUTIL/2.0"
1010 PRINT\ PRINT
1100 ON ERROR GOTO 1150
1110 FILE:4,OPEN,"foo.TX",INPUT
1120 FILE:4,DEL
1130 FILE:4,CLOSE
1150 RESET
1160 FILE:4,OPEN,"foo.TX",OUT
1200 ON ERROR GOTO 1210
1210 PRINT "What is the source volume? (1-7): ",
1212	INPUT "",V
1220	IF V<1 OR V>9 THEN 1210
1230 V$="<"+CHR$(V+48)
REM
REM  mark all directories processed
REM
1231 MAT A=-1
REM
REM  pointer to directory buffer
REM
1232 D=MEM(D$)
REM
REM  pointer to directory name list
REM
1233 D1=0
REM
REM  pointer to file name list
REM
1234 F1=0
1235 RESET
1240 PRINT
1250 PRINT "Thanks. Please wait while I read Volume ",V$,"..."
1260 PRINT
1270 N$(1)=V$\ A(1)=0\ D1=D1+1
1280 GOSUB 40000
1290 PRINT
2000 PRINT CHR$(12),"FUTIL/2",TAB(52),"Volume: ",V$
2010 PRINT\ PRINT TAB(11),"Known Directories:"
2020 FOR I=1 TO D1 STEP 2
2030	PRINT N$(I),TAB(32),
2040	IF I<D1 THEN PRINT N$(I+1) ELSE PRINT
2050 NEXT
2060 PRINT\ PRINT
2100 PRINT "M(ove), C(opy), D(elete), N(ew source) or E(xit)? ",
2110	INPUT "",Z$
2120 Z$=LEFT$(Z$,1)
2130	IF Z$="M" OR Z$="m" THEN M1=1\ GOTO 2200
2140	IF Z$="C" OR Z$="c" THEN M1=2\ GOTO 2200
2150	IF Z$="D" OR Z$="d" THEN M1=3\ GOTO 2200
2155	IF Z$="N" OR Z$="n" THEN 1200
2160	IF Z$="E" OR Z$="e" THEN 65000
2170	GOTO 2100
2200 PRINT
2210 PRINT "Source: ",V$+"<",
2220	INPUT1 "",S$
2222 Q9$=RIGHT$(S$,1)\ IF Q9$="<" OR Q9$=">" THEN S$=LEFT$(S$,LEN(S$)-1)
2225 IF S$="" THEN S$=V$ ELSE S$=V$+"<"+S$
2230 FOR I=1 TO D1
2232	IF S$=N$(I) THEN EXIT 2260
2234 NEXT
2240 PRINT "	",S$," doesn't exist."
2250 GOTO 2200
2260 P1=I
REM
REM  don't ask this when deleting
REM
2300 IF M1=3 THEN 2400
2310 PRINT "        Destination: ",
2320	INPUT1 "",T$
2330 Q9$=RIGHT$(T$,1)\IF Q9$="<" OR Q9$=">" THEN T$=LEFT$(T$,LEN(T$)-1)
2400 PRINT
2410 PRINT "Copy all or part? (a or p): ",
2420	INPUT "",Z$
2430	Z$=LEFT$(Z$,1)
2440	IF Z$="A" OR Z$="a" THEN M2=1\ GOTO 2500
2450	IF Z$="P" OR Z$="p" THEN M2=0\ GOTO 2500
2460	GOTO 2410
2500 IF M1 <> 3 THEN PRINT:4,"SCOPY"
2510 FOR I=H(P1) TO T(P1)
REM
REM  source pathname
REM
2512	Z1$=S$+"<"+F$(I)
REM
REM  destination pathname
REM
2520	Z2$=T$+"<"+F$(I)
2525	M(I)=M(I) AND 254
2530	ON M1 GOTO 2540,2550,2560
2540		P1$="move "\ P2$=" to "\ GOTO 2600
2550		P1$="copy "\ P2$=" to "\ GOTO 2600
2560		P1$="delete "\ Z2$,P2$=""\ GOTO 2600
2600	IF M2=1 THEN 2700
2610	    PRINT P1$,Z1$,P2$,Z2$,"? (y, n, x): ",
2620		INPUT "",Z$
2630		Z$=LEFT$(Z$,1)
2640		IF Z$="Y" OR Z$="y" THEN 2700
2650		IF Z$="N" OR Z$="n" THEN 2899
2660		IF Z$="X" OR Z$="x" THEN EXIT 2900
2670		IF Z$="" THEN 2899
2680		GOTO 2610
2700	ON M1 GOTO 2710,2720,2730
2710	PRINT:4,Z1$+" "+Z2$
2712	M(I)=M(I) OR 1
2714	GOTO 2899
2720	PRINT:4,Z1$+" "+Z2$
2722	GOTO 2899
2730	PRINT:4,"DELETE "+Z1$
2732	GOTO 2899
2899 NEXT
2900 PRINT:4,""
2910 IF M1<>1 THEN 2960
2920 FOR I=H(P1) TO T(P1)
2930	IF (M(I) AND 1)=0 THEN 2950
2940	Z1$=S$+"<"+F$(I)\ PRINT:4,"DELETE "+Z1$
2950 NEXT
2960 PRINT:4,";"
2970 PRINT:4,";"
2999 GOTO 2000
40000 FOR D2=1 TO D1
40002	IF A(D2)>=0 THEN EXIT 40020
40004 NEXT
REM
REM  can't find anything to do! so return...
REM
40010 RETURN
40020 Z=CALL(1,4,V+256,D,A(D2))
40030 P$=N$(D2)+"<"
REM
REM  mark head ptr to fnt
REM
40040 H(D2)=F1+1
REM
REM  process this directory...
REM
40050 GOSUB 41000
REM
REM  and mark it done.
REM
40060	A(D2)=-1
REM
REM  mark tail of last file...
REM
40070 T(D2)=F1
REM
REM  and try for more!
REM
40080 GOTO 40000
REM
REM  start of fde list
REM
41000 J=15
41010 F=PEEK(D+J)
REM
REM  end of directory
REM
41020 IF F=0 OR J=1024 THEN RETURN
REM
REM  fde deleted...skip it
REM
41030 IF (F AND 128) THEN 41300
REM
REM  length & mode bits
REM
41040 L=F AND 31\ M=F AND 224
41050 Q$=""
41060 FOR I=1 TO L
41062	Q$=Q$+CHR$(PEEK(D+J+I))
41064 NEXT
41070 Z=D+J+L
41072	X$=CHR$(PEEK(Z+1))+CHR$(PEEK(Z+2))
REM
REM  ah! a directory...
REM
41080 IF X$="DX" THEN 41200
41100 F1=F1+1
41110	F$(F1)=Q$+"."+X$
41120	M(F1)=M
41130	Z=FNR("file",P$+F$(F1))
41140 GOTO 41300
41200 D1=D1+1
41210	N$(D1)=P$+Q$
41220	Z=D+J+L+3
41230	A(D1)=PEEK(Z)+PEEK(Z+1)*256
41240	Z=FNR("directory",N$(D1))
41250 GOTO 41300
REM
REM  point to next fde
REM
41300 J=J+(F AND 31)+11
REM
REM  loop for all fde's
REM
41310 GOTO 41010
50000 DEF FNR(Z1$,Z2$)
50010	PRINT CHR$(24),"		found ",Z1$," ",Z2$,
50015	POKE 0,127
50020   RETURN 0
50099 FNEND
65000 C$=CHR$(13)
65010 PRINT:4,";"+C$+";  ALL DONE..."+C$+";"
65020 FILE:4,CLOSE
65100 PRINT CHR$(12),"FUTIL/2"
65110 PRINT\ PRINT\ PRINT
65120 INPUT "Do you want to run the command file now? ",Z$
65130	Z$=LEFT$(Z$,1)
65140	IF Z$="Y" OR Z$="y" THEN C$="foo"+C$ ELSE C$=";"+C$
65150 PRINT
65199 Z=CALL(0,C$)
