;********************************************************
;*							*
;*			Clean				*
;*							*
;*	Version 4.0			Brian Smith	*
;*	02/24/81					*
;*							*
;*	Copyright (c) 1980, Interactive Products	*
;*  Corporation dba PolyMorphic Systems 460 Ward Dr.	*
;*  Santa Barbara, CA  93111				*
;*							*
;********************************************************
;
	REFS	SYSTEM
	REF

	ORG	USER
	IDNT	$,$

TAB	EQU	9
FF	EQU	12
CR	EQU	13

	JMP	START
	RET

Hello	db	'Clean v4.0 (02/24/81)',CR,0

DCMP	MOV	A,H
	CMP	D
	RNZ
	MOV	A,L
	CMP	E
	RET
;
;
;
FILL	MOV	E,A
FILL1	MOV	A,B
	ORA	C
	RZ
	MOV	M,E
	INX	H
	DCX	B
	JMP	FILL1
;
;	Skip leading blanks.
;
BREAK	MOV	A,M
	INX	H
	CPI	' '
	JZ	BREAK
	CPI	TAB
	JZ	BREAK
	DCX	H
	RET
;
;	Find the end of the current spec pointed to by HL.
;
FEND	CALL	BREAK
FEND1	MOV	A,M
	CPI	CR
	RZ
	CPI	' '
	RZ
	CPI	TAB
	RZ
	CPI	','
	RZ
	INX	H
	JMP	FEND1
;
;	Main code.
;
START	LDA	SCHR
	ORA	A
	RZ		; Enabled only.
	LXI	H,Hello
	CALL	Msg
	LHLD	CMPTR
	SHLD	RESCAN
	CALL	FEND
	SHLD	LINEEND
	MVI	M,'<'
	INX	H
	MVI	M,19H
	INX	H
	MVI	M,CR
	LHLD	CMPTR
	LXI	D,FILE
	MVI	A,40H	; look it up.

	IF	USERS=2
	CALL	Gfid
	ELSE
	CALL	Gover
	db	'Gfid'
	ENDIF

	JNC	ST1	; Found It!?
	PUSH	PSW	; Save for a second.
	LXI	H,300H
	CALL	DCMP
	JNZ	Err
	POP	PSW	; Get flags back.
	JNZ	Err	; Couldn't find directory.
ST1	LDA	NFDIR
	MOV	B,A
	LDA	SYSRES
	CMP	B
	LXI	D,111H
	JZ	Err

	IF	USERS=2
	MOV	A,B
	ANI	7FH
	MOV	C,A
	sett	excl
	JC	Err
	ENDIF

	DI
	LXI	H,SBUF1+9
	MVI	M,0
	INX	H
	MVI	M,0
	INX	H
	LXI	D,SBUF1+0FH
	MOV	M,E
	INX	H
	MOV	M,D
	INX	H
	LXI	B,1024-12
	XRA	A
	CALL	FILL
	LHLD	DirAddr
	MOV	A,H
	ORA	L
	JNZ	ST2
	LXI	H,4
	SHLD	SBUF1+0DH
ST2
	IF	USERS=2
	MVI	A,3
	EI
	CALL	Gfid
	ELSE
	CALL	Ckdr
	STA	SBUF1
	STA	NFCK
	LHLD	DirAddr
	LXI	D,SBUF1
	LDA	NFDIR
	ANI	7FH
	MOV	C,A
	MVI	B,0	; Write.
	MVI	A,4
	EI
	CALL	Dio
	ENDIF

	JC	Err
	LHLD	LINEEND
	MVI	M,CR
	LHLD	RESCAN
	SHLD	CMPTR
	XRA	A
	CALL	Gover
	db	'Dfn2'
	RET

RESCAN	DS	2
LINEEND	DS	2
ADDR	DS	2

	END
