	PAGE
;********************************************************
;*							*
;*	       System and Environmental Equates		*
;*							*
;********************************************************

;	* * * * *   Character Constants   * * * * * 

bs	EQU	08H
tab	EQU	09H
ff	EQU	0CH
cr	EQU	0DH
ctlx	EQU	18H
esc	EQU	1BH
space	EQU	' '
comma	EQU	','
dot	EQU	'.'
colon	EQU	':'
quest	EQU	'?'
quote	EQU	'"'
equals	EQU	'='
lparen	EQU	'('
rparen	EQU	')'
zero	EQU	'0'
nine	EQU	'9'
ltra	EQU	'A'
ltrz	EQU	'Z'
del	EQU	7FH

delete	EQU	4
find	EQU	6

ON	EQU	1
OFF	EQU	0


;	* * * * *   special equates   * * * * *

ctlgrp	EQU	20H	; end of control group
grbk	EQU	7FH	; graphic blank for tabs & crs

dquest	EQU	0BFH	; a displayable question mark

lpp	EQU	13	; lines/page for ESC ?

ctldel	EQU	'_'	; ^_ means DELETE for library loader
ctlpfx	EQU	'^'	; control prefix for library loader
eschr	EQU	'['	; an escape char for control prefix

EdExt	EQU	'TX'	; this extension is for text editing
LibExt	EQU	'ED'	; and this one's for escape libraries
WildFN	EQU	'*'	; this char as a file name means to
			; use the same name as the input file
			; (applies to output files only)

;  The inhibit flags

;  inflgs:
;	| dai | dui |                       | din | ioi | 
;	|-----|-----|-----|-----|-----|-----|-----|-----|

dai	EQU	80H	; display activity inhibit
dui	EQU	40H	; display update inhibit
din	EQU	02H	; display inhibit (internal)
ioi	EQU	01H	; input/output inhibit


;	* * * * *   Markers   * * * * *

stx	EQU	82H	; start of text marker (buffer)
etx	EQU	83H	; end of text marker (buffer)
bhmkr	EQU	9AH	; block head marker
btmkr	EQU	9BH	; block tail marker
mkr	EQU	0FFH	; 'enter' function marker
dsmkr	EQU	80H	; display marker (update)

;****************
